//vc/ VC/m Access Right Class
//vc/ Copyright 1999,2002 George James
//vc/ Object:    AccessRight.js
//vc/ Component: T.AccessRight.js


	// AccessRight Class
AccessRight = {}

AccessRight.Current=Disabled;
AccessRight.windowProperties  = 'left=50,top=50,width=400,height=400,toolbar=no';
AccessRight.windowProperties += ',location=no,directories=no,status=yes,resizable=yes,menubar=no';

	// Public - Display List of access rights and make this the active folder
AccessRight.fnList = function() {
	//
	SelectedClass=AccessRight
	Class.fnUnselect()
	//
	ServerLink.fnDo('AccessRight.fnListResult','AccessRight.fnList','')
}

AccessRight.fnListResult = function(oResult) {
	//
  // Copy results from oResult to document
  ServerLink.fnUpdate(oResult,'divFolderHeadingCaption')
  ServerLink.fnUpdate(oResult,'divMainBody')
  ServerLink.fnUpdate(oResult,'divMainHead')
}

	// Private - Invoked when an item is selected on the list
AccessRight.fnSelect = function(oCell) {
	Class.fnSelect(AccessRight,oCell);
}

	// Public - Open new access right window
AccessRight.fnNew = function() {
	fnRunWindow("AccessRight.fnNew",AccessRight.windowProperties); 
}

	// Public - Open Access Right
AccessRight.fnOpen = function(sAccessRight) {
	var url;
	//
	// Build url string
	url  = parent.serverUrl ;
	url += '&page=' + escape('AccessRight.fnOpen') ;
	url += '&selectedItem=' + encodeURIComponent(sAccessRight) ;
	//
	// Open AccessRight window
	winAccessRight=window.open(url,'AccessRight',AccessRight.windowProperties) ;
	winAccessRight.focus();
}

	// Public - Fork a derived Access Right so it becomes an ordinary one
AccessRight.fnFork = function(sAccessRight) {
	var arguments;
	//
	if (!confirm("Are you sure you want to fork "+sAccessRight+" to make it independent of the template which originally derived it?")) return;
	//
	arguments = sAccessRight;
	//
	parent.serverLink.fnDo('AccessRight.fnForkResult','AccessRight.fnFork',arguments);
}

AccessRight.fnForkResult = function(result) {
	if (result!="OK") {
		alert(result);
		return;
	}
	fnRefreshSelected();
}

	// Public - Yield an underived Access Right so a template save can overwrite it and make it a derived one.
AccessRight.fnYield = function(sAccessRight) {
	var arguments;
	//
	if (!confirm("Yielding \'"+sAccessRight+"\' will permit it to be overwritten the next time a template definition which targets it generates derivatives.\n\nThe yield will cease if this definition is edited before such a derivation happens.\n\nDo you want to proceed?")) return;
	//
	arguments = sAccessRight;
	//
	parent.serverLink.fnDo('AccessRight.fnYieldResult','AccessRight.fnYield',arguments);
}

AccessRight.fnYieldResult = function(result) {
	if (result!="OK") {
		alert(result);
		return;
	}
	fnRefreshSelected();
}

	// Public - Delete an Access Right
AccessRight.fnDelete = function(sAccessRight) {
	var arguments;
	//
	if (!confirm("Are you sure you want to delete \'"+sAccessRight+"\' ?")) return;
	//
	arguments = sAccessRight;
	//
	parent.serverLink.fnDo('AccessRight.fnDeleteResult','AccessRight.fnDelete',arguments);
}

AccessRight.fnDeleteResult = function(result) {
	if (result!="OK") {
		alert(result);
		return;
	}
	AccessRight.fnList();
}

AccessRight.Item = function() {}

AccessRight.Item.fnFork = function() {
	if (typeof(AccessRight.Current)=='undefined') return;
	AccessRight.fnFork(getAttr(AccessRight.selectedCell,"gjsItem"));
}

AccessRight.Item.fnYield = function() {
	if (typeof(AccessRight.Current)=='undefined') return;
	AccessRight.fnYield(getAttr(AccessRight.selectedCell,"gjsItem"));
}

AccessRight.Item.fnDelete = function() {
	if (typeof(AccessRight.Current)=='undefined') return;
	AccessRight.fnDelete(getAttr(AccessRight.selectedCell,"gjsItem"));
}
	// Public - open selected access right (if there is one)
AccessRight.Item.fnOpen = function() {
	if (typeof(AccessRight.Current)=='undefined') return;
	AccessRight.fnOpen(getAttr(AccessRight.selectedCell,"gjsItem"));
}

  // Refresh item in list
AccessRight.fnRefreshArguments = function(oMain)   {
  //
	var arguments=""
	//
  arguments +=          getAttr(oMain,"gjsParentId")
  arguments += '\002' + gjsTree.fnMores(fnElement(getAttr(oMain,"gjsRowId")+'click').previousElementSibling)
	arguments += '\002' + getAttr(oMain,"gjsItem")
	arguments += '\002' + getAttr(oMain,"gjsRowId")
	arguments += '\002' + getAttr(fnElement(getAttr(oMain,"gjsRowId")+'body').parentNode,"gjsReferenceHeadingId")
	//
	return arguments
}

AccessRight.fnRefresh = function(arguments)   {
  //
  ServerLink.fnDo('AccessRight.fnRefreshResult','AccessRight.fnRefresh',arguments)
}

AccessRight.fnRefreshResult = function(oResult) {
  gjsTree.fnRefreshRows("divMainBody",oResult)
  gjsTree.fnDeleteRows("divRowDelete",oResult)
}

