<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">

<xsl:include href='gjsForm.xsl'/>

<xsl:template match="Form">
  <xsl:apply-templates select="accessRight"/>
</xsl:template>

<xsl:template match="accessRight">
  <xsl:variable name='readonly'>
    <xsl:choose>
      <xsl:when test='../@method="view"'>
        <xsl:text>1</xsl:text>
      </xsl:when>          
      <xsl:otherwise>
        <xsl:text>0</xsl:text>
      </xsl:otherwise>          
    </xsl:choose>
  </xsl:variable>

<gjs:form
 title='Access Right'
 width='420'
 jsFile='vc851.js'
 onload='frmMain.accessRight.focus();'
 save='{/Form/@save}'
 close='{/Form/@close}'
 delete='{/Form/@delete}'
 print='{/Form/@print}'
 help='{/Form/@help}'
 ok='{/Form/@ok}'
 cancel='{/Form/@cancel}'>

  <gjs:information>
    Access rights control the level of access of application users.
    <xsl:choose>
      <xsl:when test='@genByKey!=""'>
        This record cannot be amended because it was derived from the <xsl:value-of select='@genByKey'/> template.
      </xsl:when>
      <xsl:otherwise>
        Templates can be defined by using {variable} notation in the key field.
      </xsl:otherwise>
    </xsl:choose>
  </gjs:information>

<div id='divaccessRight' class='visible' style='min-height: 240px'>
  <gjs:frame>
  <!-- Set up frame column widths -->
  <gjs:columnWidths>
    <gjs:column width='100'/>
    <gjs:column width='290'/>
  </gjs:columnWidths>

  <gjs:fields>

    <gjs:input
     id='accessRight'
     accesskey='A'
     size='30'
     maxlength='30'
     value='{@accessRight}'
     onchange='Form.fnChanged()'
     readonly='{$readonly}'>
     <label><u>A</u>ccess right</label>
     <hint>Name that identifies an access right</hint>
    </gjs:input>

    <gjs:input
     id='description'
     accesskey='e'
     size='40'
     maxlength='200'
     value='{@description}'
     onchange='Form.fnChanged()'
     readonly='{$readonly}'>
     <label>D<u>e</u>scription</label>
     <hint>Description of this access right</hint>
    </gjs:input>



  </gjs:fields>

  <gjs:inputHidden id='revision' value='{@revision}'/>
  <gjs:inputHidden id='oldAccessRight' value='{@accessRight}'/>

  </gjs:frame>
</div>
</gjs:form>
</xsl:template>


</xsl:stylesheet>
