<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:msxsl="urn:schemas-microsoft-com:xslt"
 xmlns:gjs="http://www.georgejames.com">

<xsl:include href='gjsForm.xsl'/>

<xsl:template match="Form">
  
  <gjs:form
   title='Audit Trail'
   jsFile='AuditTrail_Details.js'
   onload='TabStrip.fnSelect(document.getElementById("tabAudit")); document.getElementById("tabAudit").focus()'
   save="{@save}"
   close='{@close}'
   delete='{@delete}'
   print='{@print}'
   help='{@help}'
   ok='{@ok}'
   cancel='{@cancel}'>


    <!-- Tab-strips -->
    <gjs:tabStrip>
      <xsl:apply-templates mode='tabStrip' />
    </gjs:tabStrip>

    <!-- Frames -->
    <xsl:apply-templates />

    <!-- A little space between the frames and the form buttons -->
    <table><tr><td height='6px'></td></tr></table>

  </gjs:form>
</xsl:template>


<!-- Tab for Audit Summary -->
<xsl:template match='/Form/audit' mode='tabStrip'>
    <gjs:tabStripTab
     id='tabAudit'
     accesskey='S'
     divId='divAudit'>
      <u>S</u>ummary
    </gjs:tabStripTab>
</xsl:template>


<!-- The main Audit Trail panel -->
<xsl:template match='/Form/audit'>
  <xsl:variable name='flagging'>
    <xsl:choose>
      <xsl:when test='/Form/parameters/@features &gt; 6'>
        <xsl:text>1</xsl:text>
      </xsl:when>          
      <xsl:otherwise>
        <xsl:text>0</xsl:text>
      </xsl:otherwise>          
    </xsl:choose>
  </xsl:variable>

  <div id='divAudit' class='tabPanelHidden' style='height: 270px'>
    <gjs:frame>
      <!-- Set up form column widths -->
      <gjs:columnWidths>
        <gjs:column width='100'/>
        <gjs:column width='440'/>
      </gjs:columnWidths>

      <gjs:fields>

    <xsl:choose>
      <xsl:when test='not(@objectVersion="")'>
        <gjs:input
         id='objectVersion'
         size='65'
         value='{@objectVersion}'
         readonly='1'>
         <label>Object version</label>
         <hint>The object version that was the subject of this event</hint>
        </gjs:input>
      </xsl:when>
      <xsl:otherwise>
        <gjs:input
         id='changeRequest'
         size='30'
         value='{@changeRequest}'
         readonly='1'>
         <label>Change request</label>
         <hint>The change request associated with this event</hint>
        </gjs:input>
      </xsl:otherwise>    
    </xsl:choose>

    <gjs:input
     id='message'
     size='65'
     value='{@message}'
     readonly='1'>
     <label>Message</label>
     <hint>A summary description of the event</hint>
    </gjs:input>

    <gjs:input
     id='user'
     size='20'
     value='{@user}'
     readonly='1'>
     <label><u>U</u>ser ID</label>
     <hint>The user who caused this event</hint>
    </gjs:input>


    <xsl:variable name='formattedDateTime'>
      <xsl:call-template name='gjs:formatDateTime'>
        <xsl:with-param name='locale' select='/Form/user/@locale'/>
        <xsl:with-param name='date' select='@dateTime'/>
      </xsl:call-template>  
    </xsl:variable>
    
    <gjs:input
     id='dateTime'
     size='20'
     value='{$formattedDateTime}'
     readonly='1'>
     <label>Time stamp</label>
     <hint>The date/time of this event</hint>
    </gjs:input>

    <gjs:input
     id='category'
     size='20'
     value='{category/@name}'
     readonly='1'>
     <label>Category</label>
     <hint>The category of this event</hint>
    </gjs:input>

    <tr>
      <td colspan='2'>
        <hr/>
      </td>
    </tr>

    <tr>
     <gjs:caption 
      for='action' 
      accesskey='F'
      readonly='0'>
       <label><u>F</u>or action</label>
     </gjs:caption>

      <td 
       width='20' title="If this flag is clicked then this audit trail message will appear in the designated user's for action list">
            <xsl:choose>
              <xsl:when test='$flagging=0'>
                <xsl:attribute name='title'>Message flagging is not available on this edition of Deltanji</xsl:attribute>  
                <img
                 id='action'
                 tabindex='0'
                 style='border: 1px solid; border-color: threedshadow threedlightshadow threedlightshadow threedshadow;'
                 src='vcm_blank.gif'/>
              </xsl:when>
              <xsl:when test='@actioned="no"'>
                <img
                 id='action'
                 tabindex='0'
                 style='border: 1px solid; border-color: threedshadow threedlightshadow threedlightshadow threedshadow;'
                 src='vcmFlag.gif'
                 onmouseover='this.src=getAttr(this,"gjsOtherImage")'
                 onmouseout='this.src=getAttr(this,"gjsCurrentImage")'
                 gjsCurrentImage='vcmFlag.gif'
                 gjsOtherImage='vcmFlagGrey.gif'
                 gjsActioned='no'
                 onclick='Form.fnChanged();fnActionToggleThis(this)'/>
              </xsl:when>
              <xsl:otherwise>
                <img
                 id='action'
                 tabindex='0'
                 style='border: 1px solid; border-color: threedshadow threedlightshadow threedlightshadow threedshadow;'
                 src='vcm_blank.gif'
                 onmouseover='this.src=getAttr(this,"gjsOtherImage")'
                 onmouseout='this.src=getAttr(this,"gjsCurrentImage")'
                 gjsCurrentImage='vcm_blank.gif'
                 gjsOtherImage='vcmFlagGrey.gif'
                 gjsActioned='yes'
                 onclick='Form.fnChanged();fnActionToggleThis(this)'/>
              </xsl:otherwise>
            </xsl:choose>
      </td>      
    </tr>

      <gjs:list1
       id='actionBy'
       accesskey='B'
       width='150'
       value='{@actionBy}'
       onchange='Form.fnChanged()'
       row='1'
       >
        <xsl:if test='@actioned="yes" or @flagging=0'>
          <xsl:attribute name='disabled'>disabled</xsl:attribute>
        </xsl:if>
        <label><u>B</u>y</label>
        <hint>The user ID of the user who has been assigned this action</hint>
        <item>
          <label></label>
          <value></value>
        </item>
        <xsl:apply-templates select='/Form/users/user' mode='list1' />
      </gjs:list1>


    <tr>
      <td colspan='2'>
        <hr/>
      </td>
    </tr>

    <gjs:input
     id='session'
     size='20'
     value='{@session}'
     readonly='1'>
     <label>Session Number</label>
     <hint>The web session ID that performed this event</hint>
    </gjs:input>

    <gjs:input
     id='transaction'
     size='20'
     value='{@transaction}'
     readonly='1'>
     <label>Transaction Number</label>
     <hint>The transaction ID that performed this event</hint>
    </gjs:input>

    <gjs:inputHidden id='item' value='{@item}'/>
    <gjs:inputHidden id='atline' value='{@atline}'/>
    <gjs:inputHidden id='revision' value='{@revision}'/>

  </gjs:fields>

  </gjs:frame>
  </div>

</xsl:template>


<!-- Tab for Transfer Event -->
<xsl:template match='/Form/transfer' mode='tabStrip'>
  <gjs:tabStripTab
   id='tabTransfer'
   accesskey='T'
   divId='divTransfer'>
    <u>T</u>ransfer Detail
  </gjs:tabStripTab>
</xsl:template>


<!-- Transfer Event form -->
<xsl:template match='/Form/transfer'>
  <div id='divTransfer' class='tabPanelHidden' style='height: 270px'>
    <gjs:frame>

      <!-- Set up form column widths -->
      <gjs:columnWidths>
        <gjs:column width='100'/>
        <gjs:column width='220'/>
        <gjs:column width='220'/>
      </gjs:columnWidths>

      <gjs:fields>

        <gjs:input
          id='function'
          size='20'
          value='{@function}'
          readonly='1'>
          <label>Function</label>
          <hint>The type of transfer</hint>
        </gjs:input>

        <tr height='25'>
          <td></td>
          <td>
            <span class='caption'>
              From
            </span>
          </td>
          <td>
            <span class='caption'>
              To
            </span>
          </td>        
        </tr>

        <tr>
          <gjs:input
            id='fromLocation'
            size='20'
            value='{@fromLocation}'
            readonly='1'
            row='0'>
            <label>Location</label>
            <hint>The source location of the transfer event</hint>
          </gjs:input>

          <gjs:input
            id='toLocation'
            size='20'
            value='{@toLocation}'
            readonly='1'
            row='0'>
            <label></label>
            <hint>The target or destination location of the transfer event</hint>
          </gjs:input>
        </tr>

        <tr>
          <gjs:input
            id='fromObjectVersion'
            size='30'
            value='{@fromObjectVersion}'
            readonly='1'
            row='0'>
            <label>Version</label>
            <hint>The source object version of the transfer event</hint>
          </gjs:input>

          <gjs:input
            id='toObjectVersion'
            size='30'
            value='{@toObjectVersion}'
            readonly='1'
            row='0'>
            <label></label>
            <hint>The target or destination object version of the transfer event</hint>
          </gjs:input>
        </tr>
        
        <tr>
          <gjs:input
            id='oldMaster'
            size='20'
            value='{@oldMaster}'
            readonly='1'
            row='0'>
            <label>Master Location</label>
            <hint>The master location of the object version before the transfer event</hint>
          </gjs:input>

          <gjs:input
            id='newMaster'
            size='20'
            value='{@newMaster}'
            readonly='1'
            row='0'>
            <label></label>
            <hint>The master location of the object version after the transfer event</hint>
          </gjs:input>
        </tr>

        <tr>
          <gjs:caption readonly='1'>
            <label>Active locations</label>
          </gjs:caption>
          <td>
            <div class='gridTableOuter' style='height: 104px; width: 160px;'>
              <table class='formLayoutTable'>
              </table>
              <div class='gridTableInner' style='height: 100px;'>
                <table class='formLayoutTable'>
                  <tr>
                    <gjs:column width='5'/>
                    <gjs:column width='155'/>
                  </tr>
                  <xsl:apply-templates select="/Form/transfer/@oldActive" mode='grid'>
                  </xsl:apply-templates>
                </table>
              </div>
            </div>
          </td>


          <td>
            <div class='gridTableOuter' style='height: 104px; width: 160px;'>
              <table class='formLayoutTable'>
              </table>
              <div class='gridTableInner' style='height: 100px;'>
                <table class='formLayoutTable'>
                  <tr>
                    <gjs:column width='5'/>
                    <gjs:column width='155'/>
                  </tr>
                  <xsl:apply-templates select="/Form/transfer/@newActive" mode='grid'>
                  </xsl:apply-templates>
                </table>
              </div>
            </div>
          </td>
        </tr>


        <xsl:variable name='fromAction'>
          <xsl:choose>
            <xsl:when test='@transferType="0"'>
              <xsl:text>Copy</xsl:text>
            </xsl:when>          
            <xsl:when test='@transferType="1"'>
              <xsl:text>Delete</xsl:text>
            </xsl:when>          
            <xsl:otherwise>
              <xsl:value-of select='@transferType' />
            </xsl:otherwise>          
          </xsl:choose>
        </xsl:variable>

        <xsl:variable name='toAction'>
          <xsl:choose>
            <xsl:when test='@action="1"'>
              <xsl:text>Add</xsl:text>
            </xsl:when>          
            <xsl:when test='@action="2"'>
              <xsl:text>Replace</xsl:text>
            </xsl:when>          
            <xsl:when test='@action="3"'>
              <xsl:text>Delete</xsl:text>
            </xsl:when>          
            <xsl:otherwise>
              <xsl:value-of select='@action' />
            </xsl:otherwise>          
          </xsl:choose>
        </xsl:variable>

        <tr>
          <gjs:input
            id='fromAction'
            size='10'
            value='{$fromAction}'
            readonly='1'
            row='0'>
            <label>Action</label>
            <hint>Whether the object was copied or deleted from the source location</hint>
          </gjs:input>

          <gjs:input
            id='toAction'
            size='10'
            value='{$toAction}'
            readonly='1'
            row='0'>
            <label></label>
            <hint>Whether the object was added, deleted or replaced at the destination location</hint>
          </gjs:input>
        </tr>


      </gjs:fields>
    </gjs:frame>

  </div>
</xsl:template>


<!-- Tab for Compile Event -->
<xsl:template match='/Form/compile' mode='tabStrip'>
  <gjs:tabStripTab
   id='tabCompile'
   accesskey='C'
   divId='divCompile'>
    <span style='color: red'><u>C</u>ompile Error</span>
  </gjs:tabStripTab>
</xsl:template>


<!-- Compile Event form -->
<xsl:template match='/Form/compile'>
  <div id='divCompile' class='tabPanelHidden' style='height: 270px'>
    <gjs:frame>

      <!-- Set up form column widths -->
      <gjs:columnWidths>
        <gjs:column width='100'/>
        <gjs:column width='440'/>
      </gjs:columnWidths>

      <gjs:fields>

        <gjs:input
          id='componentReference'
          size='60'
          value='{@componentReference}'
          readonly='1'>
          <label>Component</label>
          <hint>The component that was compiled</hint>
        </gjs:input>

        <gjs:input
          id='location'
          size='60'
          value='{@location}'
          readonly='1'>
          <label>Location</label>
          <hint>The place where the component was compiled</hint>
        </gjs:input>

        <gjs:textarea
         id='error'
         accesskey='E'
         rows='12'
         cols='67'
         value='{@error}'
         readonly='readonly'>
         <label>Error</label>
         <hint>The error output from compilation</hint>
        </gjs:textarea>

      </gjs:fields>
    </gjs:frame>

  </div>
</xsl:template>


<!-- Tab for Import Event -->
<xsl:template match='/Form/import' mode='tabStrip'>
  <gjs:tabStripTab
   id='tabImport'
   accesskey='I'
   divId='divImport'>
    <span style='color: red'><u>I</u>mport Error</span>
  </gjs:tabStripTab>
</xsl:template>


<!-- Import Event form -->
<xsl:template match='/Form/import'>
  <div id='divImport' class='tabPanelHidden' style='height: 270px'>
    <gjs:frame>

      <!-- Set up form column widths -->
      <gjs:columnWidths>
        <gjs:column width='100'/>
        <gjs:column width='440'/>
      </gjs:columnWidths>

      <gjs:fields>

        <gjs:input
          id='componentReference'
          size='60'
          value='{@componentReference}'
          readonly='1'>
          <label>Component</label>
          <hint>The component that was imported</hint>
        </gjs:input>

        <gjs:input
          id='location'
          size='60'
          value='{@location}'
          readonly='1'>
          <label>Location</label>
          <hint>The place where the component was imported</hint>
        </gjs:input>

        <gjs:textarea
         id='errorText'
         accesskey='E'
         rows='12'
         cols='67'
         value='{@errorText}'
         readonly='1'>
         <label>Error</label>
         <hint>The error output from the import</hint>
        </gjs:textarea>

      </gjs:fields>
    </gjs:frame>

  </div>
</xsl:template>


<!-- Tab for Export Event -->
<xsl:template match='/Form/export' mode='tabStrip'>
  <gjs:tabStripTab
   id='tabExport'
   accesskey='E'
   divId='divExport'>
    <span style='color: red'><u>E</u>xport Error</span>
  </gjs:tabStripTab>
</xsl:template>


<!-- Import Event form -->
<xsl:template match='/Form/export'>
  <div id='divExport' class='tabPanelHidden' style='height: 270px'>
    <gjs:frame>

      <!-- Set up form column widths -->
      <gjs:columnWidths>
        <gjs:column width='100'/>
        <gjs:column width='440'/>
      </gjs:columnWidths>

      <gjs:fields>

        <gjs:input
          id='componentReference'
          size='60'
          value='{@componentReference}'
          readonly='1'>
          <label>Component</label>
          <hint>The component that was exported</hint>
        </gjs:input>

        <gjs:input
          id='location'
          size='60'
          value='{@location}'
          readonly='1'>
          <label>Location</label>
          <hint>The place where the component was exported</hint>
        </gjs:input>

        <gjs:textarea
         id='errorText'
         accesskey='E'
         rows='12'
         cols='67'
         value='{@errorText}'
         readonly='1'>
         <label>Error</label>
         <hint>The error output from the export</hint>
        </gjs:textarea>

      </gjs:fields>
    </gjs:frame>

  </div>
</xsl:template>


<!-- Tab for Delete Event -->
<xsl:template match='/Form/delete' mode='tabStrip'>
  <gjs:tabStripTab
   id='tabDelete'
   accesskey='D'
   divId='divDelete'>
    <span style='color: red'><u>D</u>elete Error</span>
  </gjs:tabStripTab>
</xsl:template>


<!-- Delete Event form -->
<xsl:template match='/Form/delete'>
  <div id='divDelete' class='tabPanelHidden' style='height: 270px'>
    <gjs:frame>

      <!-- Set up form column widths -->
      <gjs:columnWidths>
        <gjs:column width='100'/>
        <gjs:column width='440'/>
      </gjs:columnWidths>

      <gjs:fields>

        <gjs:input
          id='componentReference'
          size='60'
          value='{@componentReference}'
          readonly='1'>
          <label>Component</label>
          <hint>The component that was deleted</hint>
        </gjs:input>

        <gjs:input
          id='location'
          size='60'
          value='{@location}'
          readonly='1'>
          <label>Location</label>
          <hint>The place where the component was deleted</hint>
        </gjs:input>

        <gjs:textarea
         id='errorText'
         accesskey='E'
         rows='12'
         cols='67'
         value='{@errorText}'
         readonly='1'>
         <label>Error</label>
         <hint>The error output from the delete</hint>
        </gjs:textarea>

      </gjs:fields>
    </gjs:frame>

  </div>
</xsl:template>

<!-- Tab for Error Event -->
<xsl:template match='/Form/error' mode='tabStrip'>
  <gjs:tabStripTab
   id='tabError'
   accesskey='E'
   divId='divError'>
    <span style='color: red'><u>E</u>rror</span>
  </gjs:tabStripTab>
</xsl:template>


<!-- Error Event form -->
<xsl:template match='/Form/error'>
  <div id='divError' class='tabPanelHidden' style='height: 270px'>
    <gjs:frame>

      <!-- Set up form column widths -->
      <gjs:columnWidths>
        <gjs:column width='100'/>
        <gjs:column width='440'/>
      </gjs:columnWidths>

      <gjs:fields>

        <gjs:input
          id='dollarZerror'
          size='65'
          value='{@dollarZerror}'
          readonly='1'>
          <label>$zerror</label>
          <hint>Error code</hint>
        </gjs:input>

        <gjs:input
          id='zer'
          size='65'
          value='{@zer}'
          readonly='1'>
          <label>Forced error</label>
          <hint>Forced error code</hint>
        </gjs:input>

		    <tr valign='top'>
		      <gjs:caption for='divVariables'>
		        <label>Variables</label>
		      </gjs:caption>
		      <td>
		        <div class='gridTableOuter' style='height: 190px; width: 440px;'>
		          <table class='formLayoutTable'>
		          </table>
		          <div class='gridTableInner' style='height: 190px;' id='divVariables'>
		            <table class='formLayoutTable'>
		              <tr>
		                <gjs:column width='2'/>
		                <gjs:column width='95'/>
		                <gjs:column width='341'/>
		              </tr>
		              <xsl:apply-templates 
		               select='variables/variable'
		               mode='grid'/>
		            </table>
		          </div>
		        </div>
		      </td>
		    </tr>

      </gjs:fields>
    </gjs:frame>

  </div>
</xsl:template>

<xsl:template match='variable' mode='grid'>
  <tr>
    <td></td>
    <td>
      <input 
       type='text' 
       size='12'
       id='name' 
       name='name'
       readonly='true'
       value='{@name}' 
       class='inputDisabled' />
    </td>
    <td>
      <input 
       type='text' 
       size='43'
       id='value' 
       name='value' 
       readonly='true'
       value='{@value}' 
       class='inputDisabled' />
    </td>
  </tr>
</xsl:template>


<!-- Tab for Action Events -->
<xsl:template match='/Form/action' mode='tabStrip'>
  <gjs:tabStripTab
   id='tabAction'
   accesskey='A'
   divId='divAction'>
    <u>A</u>ctions
  </gjs:tabStripTab>
</xsl:template>


<!-- Action Event form -->
<xsl:template match='/Form/action'>
  <div id='divAction' class='tabPanelHidden' style='height: 270px'>
    <gjs:frame>

      <!-- Set up form column widths -->
      <gjs:columnWidths>
        <gjs:column width='100'/>
        <gjs:column width='440'/>
      </gjs:columnWidths>

      <gjs:fields>

    <tr>
      <gjs:caption for='actionEvents' readonly='1'>
        <label>
          Action events
        </label>
      </gjs:caption>
      <td>
        <div class='gridTableOuter' style='height: 200px; width: 440px;'>
          <table class='formLayoutTable'>
            <tr>
              <td width="12px"></td>
              <td width="40px"></td>
              <td width="100px">
                <span style="white-space: nowrap">For Action By</span>
              </td>
              <td width="150px">
                <span style="white-space: nowrap">Date/Time</span>
              </td>
              <td width="100px">
                <span style="white-space: nowrap">Actioned By</span>
              </td>
            </tr>
          </table>
          <div class='gridTableInner' style='height: 200px;' id='divLocations'>
            <table class='formLayoutTable'>
              <tr>
                <gjs:column width='10'/>
                <gjs:column width='40'/>
                <gjs:column width='100'/>
                <gjs:column width='150'/>
                <gjs:column width='100'/>
              </tr>
              <xsl:apply-templates select="/Form/action/actioned" mode='grid'>
              </xsl:apply-templates>
            </table>
          </div>
        </div>
      </td>
    </tr>

      </gjs:fields>

    </gjs:frame>

  </div>
</xsl:template>


  <xsl:template match='/Form/action/actioned' mode='grid'>

    <xsl:variable name='formattedDateTime'>
      <xsl:call-template name='gjs:formatDateTime'>
        <xsl:with-param name='locale' select='/Form/user/@locale'/>
        <xsl:with-param name='date' select='@date'/>
      </xsl:call-template>  
    </xsl:variable>

    <tr>
      <td></td>
      <td>
        <xsl:choose>
          <xsl:when test='@actioned="true"'>
            <img src='vcmFlagGrey.gif'/>
          </xsl:when>
          <xsl:otherwise>
            <img src='vcmFlag.gif'/>
          </xsl:otherwise>
        </xsl:choose>
      </td>  
      <td><xsl:value-of select='@actionBy' /></td>
      <td><xsl:value-of select='$formattedDateTime' /></td>
      <td><xsl:value-of select='@user' /></td>
    </tr>

  </xsl:template>


  <xsl:template match='/Form/transfer/@oldActive | /Form/transfer/@newActive' name='locations' mode='grid'>
    <xsl:param name='locations' select='.'/>
    <xsl:variable name='location' select='substring-before(concat($locations,","),",")'/>
 
        <!-- Start actual content of row -->
        <tr>
          <td></td>
          <td><xsl:value-of select='$location' /></td>
        </tr>
        <!-- End actual content of row -->
            
      <!-- rinse and repeat -->
      <xsl:if test='contains($locations,",")'>
        <xsl:call-template name='locations'>
          <xsl:with-param name='locations' select='substring-after($locations,",")'/>
        </xsl:call-template>        
      </xsl:if>
 
  </xsl:template>


  <!-- Action By list box -->
  <xsl:template match='/Form/users/user' mode="list1">
    <item>
      <label><xsl:value-of select="@user" /></label>
      <value><xsl:value-of select="@user" /></value>
    </item>
  </xsl:template>


  <!-- Swallow content of some elements -->
  <xsl:template match="/Form/parameters">
  </xsl:template>
  <xsl:template match="/Form/user">
  </xsl:template>
  <xsl:template match="/Form/users">
  </xsl:template>


</xsl:stylesheet>
