<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet 
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">

<!-- Deleted Change Request List
     ===========================
-->

<xsl:import href='gjsTree.xsl' />
<xsl:include href='ServerLink.xsl' />
<xsl:include href='gjsControlsTemplates.xsl' />


<xsl:template match="/ServerLink/Rows">

  <div id='divFolderHeadingCaption'>
    Deleted Change Requests
  </div>
  
  <div id='divMainHead'>
    <xsl:call-template name='divMainHead' />
  </div>

  <xsl:call-template name='gjs:tree' />

</xsl:template>

<!-- Column headings for main panel -->
<xsl:template name='divMainHead'>

   	<table class='layoutTable' width='1000' >
  	  <tr>

        <xsl:call-template name='gjs:treeMoresMainHeading' />

        <td width='25'></td>

        <xsl:call-template name='gjs:treeColumnHeading'>
          <xsl:with-param name='width' select='"130"'/> 
          <xsl:with-param name='caption'>Change Request</xsl:with-param>
          <xsl:with-param name='selected' select='"ascending"'/>
        </xsl:call-template>
      
        <td width='*'></td>

      </tr>
    </table>
</xsl:template>

<xsl:template name='folderRowAttributes'>
  <xsl:variable name='onfocus'>
    <xsl:text>Main.fnSetMainHead("</xsl:text>
    <xsl:value-of select='/ServerLink/@runId' />
    <xsl:text>_mainHead");</xsl:text>
  </xsl:variable>
  <xsl:attribute name='onfocus'><xsl:value-of select='$onfocus' /></xsl:attribute>
  <xsl:attribute name='onclick'><xsl:value-of select='$onfocus' /></xsl:attribute>
</xsl:template>


<!-- Main folder content -->
<xsl:template name='folderContent'>
  <xsl:param name='rowId'/>

  <!-- Icon for Object -->
  <td class='noHighlight' width='25'>
    <img
     src='{@icon}'
     title='{@iconTitle}'
     width='25'
     height='16'/>
  </td>

  <!-- change request cell -->
  <td
   class='treeCell'
   width='100'
   nowrap='nowrap'>
    <span
     nowrap='nowrap'
     id='{$rowId}main'
     gjsIconId='{$rowId}icon'
     gjsItem='{changeRequest/@item}'
     gjsParentId='{/ServerLink/Rows/@parentId}'
     >
       <xsl:value-of select='changeRequest/@item'/>
    </span>
  </td>

</xsl:template>

  <!-- Sub-folder method -->
  <xsl:template name='subFolderMethod'>
    <xsl:text>AuditTrail.fnListDeletedChangeRequestAudit</xsl:text>
  </xsl:template>


  <!-- Sub-folder arguments -->
  <xsl:template name='subFolderArguments'>
    <xsl:param name='rowId'/>
    
    <xsl:text>"</xsl:text>
      <xsl:value-of select='$rowId'/>
    <xsl:text>main"</xsl:text>
    <xsl:text>+delimiter+"</xsl:text><xsl:value-of select='changeRequest/@item'/><xsl:text>"</xsl:text>
    <xsl:text>+delimiter+gjsTree.fnMores(gCurrentCell)</xsl:text>

  </xsl:template>


</xsl:stylesheet>
