//vc/ VC/m ChangeRequest Class
//vc/ Copyright 1999,2004 George James
//vc/ Object:    ChangeRequest.js
//vc/ Component: T.ChangeRequest.js


ChangeRequest = {}


	// Initialise to no current selection
ChangeRequest.Current=Disabled;

  // If dimensions of window have to be changed, make same change in vc720.js
  // vc720.js cannot access ChangeRequest class because it must be able to operate
  // standalone, e.g. from Studio transfer dialog 
ChangeRequest.windowProperties  = 'left=100,top=100,height=450,width=680,toolbar=no'
ChangeRequest.windowProperties += ',location=no,directories=no,status=no,resizable=yes,menubar=no';

ChangeRequest.currentFolder = null; 


	// Public - Display List of items and make this the active folder
ChangeRequest.fnList = function() {
	//
	var html,arguments;
	//
	SelectedClass=ChangeRequest;
	Class.fnUnselect();
	//
	fnMessageSelecting();
	//
	// Get Change Request table (null select will default to last used)
	arguments = getAttr(g_oSelectedFolder,'gjsItem') ; // Location
	if ($('#lstSelect').scombobox('val')=='') {
		arguments += delimiter + Select.fnFilters();
		parent.serverLink.fnDo('ChangeRequest.fnPrepareSelectorResult','ChangeRequest.fnPrepareSelector',arguments);
	} else {
		arguments += delimiter + $('#lstSelect').scombobox('val');
		arguments += delimiter + Select.fnFilters();
		parent.serverLink.fnDo('ChangeRequest.fnListResult','ChangeRequest.fnList',arguments);
	}
}


ChangeRequest.fnPrepareSelectorResult = function(oResult) {
	//
	var arguments;
	//
	// Update Select toolbars
  ServerLink.fnUpdate(oResult,'divToolbarSelect')
  Select.fnConvertList()
  ServerLink.fnUpdate(oResult,'divToolbarFilters')
	//
	// Check for error messages
	if (oResult.getElementById('divInfo')) {
		document.getElementById('divMainBody').innerHTML=oResult.getElementById('divInfo').outerHTML
	}
	//
	// Now get the Change Request list
	if ($('#lstSelect').scombobox('val')!='') {
		arguments = getAttr(g_oSelectedFolder,'gjsItem'); // Location code
		arguments += delimiter + $('#lstSelect').scombobox('val');
		arguments += delimiter + Select.fnFilters();
		// Queue the subsequent server-side call rather than invoking it directly, otherwise it happens before an already-queued reset of the wait-cursor
		setTimeout('parent.serverLink.fnDo("ChangeRequest.fnListResult","ChangeRequest.fnList",' + arguments.quote() + ')',0);
	}
}


ChangeRequest.fnListResult = function(oResult) {
  //
  // Check for error messages
  if (oResult.getElementById('divInfo')) {
    document.getElementById('divMainBody').innerHTML=oResult.getElementById('divInfo').outerHTML
  }
  //
  ServerLink.fnUpdate(oResult,'divToolbarSelect')
  Select.fnConvertList()
  ServerLink.fnUpdate(oResult,'divToolbarFilters')
  ServerLink.fnUpdate(oResult,'divFolderHeadingCaption')
  ServerLink.fnUpdate(oResult,'divMainBody')
  ServerLink.fnUpdate(oResult,'divMainHead')
}


	// Public - Display List of items and make this the active folder
ChangeRequest.fnListAll = function(oFolder) {
	//
	var html,arguments;
	//
	// Guarantee transfer menu from object found under top-level Change Requests folder passes empty from-location
	if (typeof getAttr(oFolder,'gjsItem') == 'undefined') setAttr(oFolder,'gjsItem','');
	//
	SelectedClass=ChangeRequest;
	Class.fnUnselect();
	//
	fnMessageSelecting();
	//
	// Get Change Request table (null select will default to last used)
	arguments = '' ; // No Location
	if ($('#lstSelect').scombobox('val')=='') {
		arguments += delimiter + Select.fnFilters();
		parent.serverLink.fnDo('ChangeRequest.fnPrepareSelectorAllResult','ChangeRequest.fnPrepareSelector',arguments);
	} else {
		arguments += delimiter + $('#lstSelect').scombobox('val');
		arguments += delimiter + Select.fnFilters();
		parent.serverLink.fnDo('ChangeRequest.fnListResult','ChangeRequest.fnList',arguments);
	}
}


ChangeRequest.fnPrepareSelectorAllResult = function(oResult) {
	//
	var arguments;
	//
	// Update Select toolbars
  ServerLink.fnUpdate(oResult,'divToolbarSelect')
  Select.fnConvertList()
  ServerLink.fnUpdate(oResult,'divToolbarFilters')
	//
	// Check for error messages
	if (oResult.getElementById('divInfo')) {
		document.getElementById('divMainBody').innerHTML=oResult.getElementById('divInfo').outerHTML
	}
	//
	// Now get the Change Request list
	if ($('#lstSelect').scombobox('val')!='') {
		arguments = ''; // No location code
		arguments += delimiter + $('#lstSelect').scombobox('val');
		arguments += delimiter + Select.fnFilters();
		// Queue the subsequent server-side call rather than invoking it directly, otherwise it happens before an already-queued reset of the wait-cursor
		setTimeout('parent.serverLink.fnDo("ChangeRequest.fnListResult","ChangeRequest.fnList",' + arguments.quote() + ')',0);
	}
}


	// Public - New Change Request
ChangeRequest.fnNew = function() {
	ChangeRequest.fnOpen("");
}


	// Public - Open a Change Request for Editing
ChangeRequest.fnOpen = function(sChangeRequest) {
	var url;
	//
	// Build url string
	url  = parent.serverUrl 
	url += '&page=' + 'ChangeRequest.fnOpen' ;
	url += '&user=' + encodeURIComponent(user) ;
	url += '&chref=' + encodeURIComponent(sChangeRequest) ;
	url += '&type=?' ;
	//
	// Open change request window
	winChref=window.open(url,'_blank',ChangeRequest.windowProperties) ;
	winChref.focus();
}


	// Public - Open the CR lookup dialog
ChangeRequest.fnFind = function(sChangeRequest) {
	var url;
	//
	// If none passed seek all, otherwise treat as a CR prefix
	if (typeof(sChangeRequest)=='undefined') sChangeRequest='';
	//
	// Build url string
	url  = parent.serverUrl 
	url += '&page=' + 'ChangeRequest.fnOpen' ;
	url += '&user=' + encodeURIComponent(user) ;
	url += '&chref=' + encodeURIComponent(sChangeRequest+'*') ;
	url += '&close=' + 'parent.opener.ChangeRequest.fnOpen' ;
	url += '&type=' ;
	//
	// Open change request lookup window (different name because if the user opens a CR that will use one called ChangeRequest)
	winChref=window.open(url,'_blank',ChangeRequest.windowProperties) ;
	winChref.focus();
}


	// Public - delete a Change Request
ChangeRequest.fnDelete = function(sChangeRequest,sChangeRequestPrompt) {
	//
	var arguments,yn
	//
	if (typeof(sChangeRequestPrompt)=='undefined') sChangeRequestPrompt="Change Request"
	//
	yn=confirm("Are you sure you want to DELETE "+sChangeRequestPrompt+" " + sChangeRequest + "?")
	if (!yn) return
	//
	arguments  = sChangeRequest
	parent.serverLink.fnDo('ChangeRequest.fnDeleteResult','ChangeRequest.fnDelete',arguments)
}

ChangeRequest.fnDeleteResult = function(oResult) {
	//
	if (oResult.getElementById('divError')) return
	//
  AuditTrail.fnAppendMessages(oResult)
	fnRefreshSelected()
}


	// Public - Transfer Object
ChangeRequest.fnTransfer = function(sChangeRequest,sFunction,sLcode1,sLcode2) {
	var url;
	//
	// Build url string
	url = parent.serverUrl
	url += '&page=' + 'ChangeRequest.fnTransfer';
	url += '&function=' + encodeURIComponent(sFunction);
	url += '&obv=' + encodeURIComponent(sChangeRequest);
	url += '&lcode1=' + encodeURIComponent(sLcode1);
	url += '&lcode2=' + encodeURIComponent(sLcode2);
	url += '&user=' + encodeURIComponent(user);
	url += '&obvType=CHREF';
	//
	// Open transfer window
	winTransfer=window.open(url,'Transfer',Object.windowProperties) ;
	winTransfer.focus();
}

	// Public - Transfer CR Selection
ChangeRequest.fnTransferMultiple = function(sFunction,sLcode1,sLcode2) {
	fnInvokeOnSelection('ChangeRequest.fnTransferMultipleDo','"'+sFunction+'","'+sLcode1+'","'+sLcode2+'"');
}


	// Private - Transfer CR Selection
ChangeRequest.fnTransferMultipleDo = function(iSelKey,sFunction,sLcode1,sLcode2) {
	var url;
	//
	// Build url string
	url = parent.serverUrl
	url += '&page=' + 'ChangeRequest.fnTransfer';
	url += '&function=' + encodeURIComponent(sFunction);
	url += '&lcode1=' + encodeURIComponent(sLcode1);
	url += '&lcode2=' + encodeURIComponent(sLcode2);
	url += '&user=' + encodeURIComponent(user);
	url += '&obvType=SEL';
	url += '&obv=' + encodeURIComponent(iSelKey);
	//
	// Open transfer window
	winTransfer=window.open(url,'Transfer',Object.windowProperties) ;
	winTransfer.focus();
}


	// Cancel
ChangeRequest.fnCancel = function(sChangeRequest) {
	//
	// Remember Change Request for second call
	ChangeRequest.fnCancel.sChangeRequest=sChangeRequest
	//
	// First check whether this version is valid to cancel
	parent.serverLink.fnDo('ChangeRequest.fnCancelValidateResult','ChangeRequest.fnCancelValidate',sChangeRequest)
}

ChangeRequest.fnCancelValidateResult = function(oResult) {
	//
	//
	if (!AuditTrail.fnRenderErrors(oResult)) return
	//
	parent.serverLink.fnDo('ChangeRequest.fnCancelResult','ChangeRequest.fnCancel',ChangeRequest.fnCancel.sChangeRequest)
}

ChangeRequest.fnCancelResult = function(oResult) {
  AuditTrail.fnAppendMessages(oResult)
  fnRefreshSelected()  
}


	// Public - Remove a member CR from a change request
	//          NB this is also called from ChangeRequest.Item.fnRemove() method
ChangeRequest.fnRemove = function(sMemberCR,sMemberPtext,sChangeRequest,sPtext,sRowId) {
	//
	var yn,arguments
	
	yn=confirm("Are you sure you want to remove " + sMemberPtext + " " + sMemberCR + " from " + sPtext + " " + sChangeRequest + " ?")
	if (yn) {
		arguments = sMemberCR 
		arguments += delimiter + sChangeRequest
		arguments += delimiter + sRowId
		parent.serverLink.fnDo('ChangeRequest.fnRemoveResult','ChangeRequest.fnRemoveFromChangeRequest',arguments);
	}
}

ChangeRequest.fnRemoveResult = function(oResult) {
	AuditTrail.fnAppendMessages(oResult)  
	gjsTree.fnDeleteRows("divRowDelete",oResult)
}


	// Public - Remove multiple CRs from a change request
ChangeRequest.fnRemoveMultiple = function(sChangeRequest,sPtext,sParentId) {
	var yn
	
	yn=confirm("Are you sure you want to remove " + Class.fnSelectionCount() + " change requests from "+sPtext+" "+sChangeRequest+" ?")
	if (yn) {
		fnInvokeOnSelection('ChangeRequest.fnRemoveMultipleDo','"'+sChangeRequest+'","'+sParentId+'"');
	}
}


	// Private - Perform multiple CR removal from a change request
ChangeRequest.fnRemoveMultipleDo = function(iSelKey,sChangeRequest,sParentId) {
	var arguments,oEl,oEl2
	arguments = iSelKey 
	arguments += delimiter + sChangeRequest
	//
	// Select the CR element so fnRefreshSelected refreshes only this when server side work has been done
	oEl=document.getElementById(sParentId)
	// If items being removed are part of a hybrid CR containing CRs and objects then we have to go one level up
	if (getAttr(oEl,'gjsParentId')!='') {
		oEl2=document.getElementById(getAttr(oEl,'gjsParentId'))
		if ((getAttr(oEl2,'gjsItemType')==getAttr(oEl,'gjsItemType'))&&(getAttr(oEl2,'gjsItem')==getAttr(oEl2,'gjsItem'))) oEl=oEl2
	}
	// Do it this way to ensure post-remove adds go to correct CR
	Class.fnClear()
	Class.fnSelect2(ChangeRequest,oEl)
	
	parent.serverLink.fnDo('ChangeRequest.fnRemoveMultipleResult','ChangeRequest.fnRemoveMultipleFromChangeRequest',arguments);
}

ChangeRequest.fnRemoveMultipleResult = function(oResult) {
	AuditTrail.fnAppendMessages(oResult)
	fnRefreshSelected()  
}


	// Public - Compare Change Request members with predecessors using Beyond Compare
ChangeRequest.fnBCompare = function(sChangeRequest) {
	//
	 // Build url string
	var url = parent.serverUrl;
	url += '&page=' + encodeURIComponent('ChangeRequest.fnBCompare.raw');
	url += '&arguments=' + encodeURIComponent(sChangeRequest);

	// Build properties string
	var windowProperties  = 'left=50,top=30,width=50,height=50,toolbar=no';
	windowProperties += ',location=no,directories=no,status=no,resizable=no,menubar=no';

	// Open report window (always in a new window)
	winPage = window.open(url, 'ChangeRequestfnBCompare', windowProperties);
}

  // Public - Refresh change request row in current location context
ChangeRequest.fnRefreshArguments = function(oMain) {
	//
	var arguments=""
	//
	//
	// Don't try to build refresh arguments if selected item is in audit record
	if (typeof(getAttr(oMain,'gjsRowId'))!='undefined') {
		arguments +=          getAttr(oMain,'gjsParentId') // parentId
		arguments += '\002' + gjsTree.fnMores(fnElement(getAttr(oMain,'gjsRowId')+'click').previousElementSibling) // mores
		arguments += '\002' + ((getAttr(g_oSelectedFolder,'gjsItem'))? getAttr(g_oSelectedFolder,'gjsItem') : '') // location
		arguments += '\002' + getAttr(oMain,'gjsItem') // changeRequest
		arguments += '\002' + getAttr(oMain,'gjsRowId') // rowId
		arguments += '\002' + getAttr(fnElement(getAttr(oMain,'gjsRowId')+'body').parentNode,'gjsReferenceHeadingId') // headingId
	}
	//
	return arguments
}


ChangeRequest.fnRefresh = function(arguments) {
  // Do nothing if arguments are empty (e.g. selected item was in an audit record)
  if (arguments.match(/\x03*/g).length==1) return;
  //
  ServerLink.fnDo('ChangeRequest.fnRefreshResult','ChangeRequest.fnRefresh',arguments)
}

ChangeRequest.fnRefreshResult = function(oResult) {
  gjsTree.fnRefreshRows("divMainBody",oResult)
  gjsTree.fnDeleteRows("divRowDelete",oResult)
}


ChangeRequest.Item = {

 fnOpen: function() {
	if (typeof(ChangeRequest.Current)=='undefined') return;
	ChangeRequest.fnOpen(getAttr(ChangeRequest.selectedCell,'gjsItem'));
 },

	// Public - Should Open menu option be offered?
 fnOpen$MenuState: function() {
  return (Class.fnSelectionCount()==1);
 },

	// Public - Delete change request
 fnDelete: function() {
	//
	if (typeof(ChangeRequest.Current)=='undefined') return
	ChangeRequest.fnDelete(getAttr(ChangeRequest.selectedCell,'gjsItem'),getAttr(ChangeRequest.selectedCell,'gjsPtext'))
 },

	// Public - Delete change request, or remove a member from it
fnOnKeyDel: function() {
	//
	if (typeof(ChangeRequest.Current)=='undefined') return
	//
	// If Change request is displayed as a sub-folder of a CR then remove it from the
	// CR, otherwise delete the whole change request
	if (getAttr(ChangeRequest.selectedCell,'gjsParentId')!="") {
		ChangeRequest.Item.fnRemove()
		return
	}
	//
	ChangeRequest.fnDelete(getAttr(ChangeRequest.selectedCell,'gjsItem'),getAttr(ChangeRequest.selectedCell,'gjsPtext'))
 },

  // Public - Should Delete menu option be offered?
 fnDelete$MenuState: function() {
  return (Class.fnSelectionCount()==1);
 },

	// Public - open selected user (if there is one)
 fnTransfer: function(sFunction,sLcode1,sLcode2) {
	if (typeof(ChangeRequest.Current)=='undefined') return
	if (Class.fnSelectionCount()==1) {
		ChangeRequest.fnTransfer(getAttr(ChangeRequest.selectedCell,'gjsItem'),sFunction,sLcode1,sLcode2)
	}
	else {
		ChangeRequest.fnTransferMultiple(sFunction,sLcode1,sLcode2);
	}
 },

	// Public - Remove member CR from Change Request
 fnRemove: function() {
	var sParentId,oParent
  
	if (typeof(ChangeRequest.Current)=='undefined') return;
	sParentId=getAttr(ChangeRequest.selectedCell,'gjsParentId')
	//
	if (sParentId=="") return;
	oParent=document.getElementById(sParentId);
	if (!oParent) return;
	if (getAttr(oParent,'gjsItemType')!="CHREF") return;
	//
	if (Class.fnSelectionCount()==1) {
		ChangeRequest.fnRemove(getAttr(ChangeRequest.selectedCell,'gjsItem'),getAttr(ChangeRequest.selectedCell,'gjsPtext'),getAttr(oParent,'gjsItem'),getAttr(oParent,'gjsPtext'),getAttr(ChangeRequest.selectedCell,'gjsRowId'));
	}
	else {
		if (Class.fnSelectionIsContiguous()) ChangeRequest.fnRemoveMultiple(getAttr(oParent,'gjsItem'),getAttr(oParent,'gjsPtext'),sParentId);
	}
 },
 
	// Public - Should Remove menu option be offered?
 fnRemove$MenuState: function() {
	if (getAttr(ChangeRequest.selectedCell,'gjsParentId')=="") return false;
	oParent=document.getElementById(getAttr(ChangeRequest.selectedCell,'gjsParentId'));
	if (!oParent) return false;
	if (getAttr(oParent,'gjsItemType')!="CHREF") return false;
	return Class.fnSelectionIsContiguous();
 },

	// Public - Remove parent object from Change Request
 fnRemoveObject: function() {
	var sParentId,oParent
  
	if (typeof(ChangeRequest.Current)=='undefined') return;
	sParentId=getAttr(ChangeRequest.selectedCell,'gjsParentId')
	//
	if (sParentId=="") return;
	oParent=document.getElementById(sParentId);
	if (!oParent) return;
	if (getAttr(oParent,'gjsItemType')!="OBJECT") return;
	//
	if (Class.fnSelectionCount()==1) {
		Object.fnRemove(getAttr(oParent,'gjsItem'),getAttr(ChangeRequest.selectedCell,'gjsItem'),getAttr(ChangeRequest.selectedCell,'gjsPtext'),getAttr(ChangeRequest.selectedCell,'gjsRowId'));
	}
 },
 
	// Public - Should Remove Object menu option be offered?
 fnRemoveObject$MenuState: function() {
	if (getAttr(ChangeRequest.selectedCell,'gjsParentId')=="") return false;
	oParent=document.getElementById(getAttr(ChangeRequest.selectedCell,'gjsParentId'));
	if (!oParent) return false;
	if (getAttr(oParent,'gjsItemType')!="OBJECT") return false;
	return (Class.fnSelectionCount()==1);
 },

	// Public - Cancel Version
 fnCancel: function() {
	if (typeof(ChangeRequest.Current)=='undefined') return
	ChangeRequest.fnCancel(getAttr(ChangeRequest.selectedCell,'gjsItem'))
 },

	// Public - Should Cancel menu option be offered?
 fnCancel$MenuState: function() {
  return (Class.fnSelectionCount()==1);
 },

	// Public - Compare
 fnBCompare: function() {
	if (typeof(ChangeRequest.Current)=='undefined') return
	ChangeRequest.fnBCompare(getAttr(ChangeRequest.selectedCell,'gjsItem'))
 },

	// Public - Should Compare menu option be offered?
 fnBCompare$MenuState: function() {
  return (Class.fnSelectionCount()==1);
 },

	// Public - Add item to worklist
 fnWorkListCopy: function() {
	fnWorkListCopy();
 },

	// Public - Paste worklist onto selected item
 fnWorkListPaste: function() {
	fnWorkListPaste()
 },

	// Public - Should Paste menu option be offered?
 fnWorkListPaste$MenuState: function() {
  if (Class.fnSelectionCount()!=1) return false;
  if (fnWorkListCount('OBJECT')>0) return true;
  if (fnWorkListCount('CHREF')>0) return true;
  return false;
 }
}
