<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">

<xsl:include href='gjsForm.xsl'/>

<xsl:template match="Form">
  <xsl:apply-templates select="device"/>
</xsl:template>

<xsl:template match="device">

<gjs:form
 title='Print Devices'
 jsFile='vcset32.js'
 onload='frmMain.device.focus();'
 save='{/Form/@save}'
 close='{/Form/@close}'
 delete='{/Form/@delete}'
 print='{/Form/@print}'
 help='{/Form/@help}'
 ok='{/Form/@ok}'
 cancel='{/Form/@cancel}'>
 
  <gjs:information>
    This form is used to describe the characteristics of printer device types.
  </gjs:information>

<div id='divDevice' class='visible' style='height: 240'>
  <gjs:frame>
  <!-- Set up frame column widths -->
  <gjs:columnWidths>
    <gjs:column width='150'/>
    <gjs:column width='400'/>
  </gjs:columnWidths>

  <gjs:fields>

    <gjs:input
     id='device'
     accesskey='V'
     size='40'
     maxlength='40'
     value='{@device}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label>De<u>v</u>ice</label>
     <hint>Enter a name that identifies the device type</hint>
    </gjs:input>

    <gjs:input
     id='pageWidth'
     accesskey='W'
     size='3'
     maxlength='3'
     value='{@pageWidth}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label>Page <u>w</u>idth (chars)</label>
     <hint>The width of a page in characters</hint>
    </gjs:input>

    <gjs:input
     id='pageLength'
     accesskey='L'
     size='3'
     maxlength='3'
     value='{@pageLength}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label>Page <u>l</u>ength (lines)</label>
     <hint>The length of a page in lines</hint>
    </gjs:input>

    <tr><td height='16'></td></tr>
    <tr><td colspan='2'>Enter the ASCII code for the following graphic characters:</td></tr>
    <gjs:input
     id='horizontalBar'
     accesskey='Z'
     size='3'
     maxlength='3'
     value='{@horizontalBar}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label>Hori<u>z</u>ontal line</label>
     <hint>The character code for a horizontal line</hint>
    </gjs:input>

    <gjs:input
     id='verticalBar'
     accesskey='V'
     size='3'
     maxlength='3'
     value='{@verticalBar}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label><u>V</u>ertical line</label>
     <hint>The character code for a vertical line</hint>
    </gjs:input>

    <gjs:input
     id='topLeftCorner'
     accesskey='T'
     size='3'
     maxlength='3'
     value='{@topLeftCorner}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label><u>T</u>op left corner</label>
     <hint>The character code for the top left corner of a box</hint>
    </gjs:input>

    <gjs:input
     id='topRightCorner'
     accesskey='T'
     size='3'
     maxlength='3'
     value='{@topRightCorner}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label><u>T</u>op right corner</label>
     <hint>The character code for the top right corner of a box</hint>
    </gjs:input>

    <gjs:input
     id='bottomLeftCorner'
     accesskey='B'
     size='3'
     maxlength='3'
     value='{@bottomLeftCorner}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label><u>B</u>ottom left corner</label>
     <hint>The character code for the bottom left corner of a box</hint>
    </gjs:input>

    <gjs:input
     id='bottomRightCorner'
     accesskey='B'
     size='3'
     maxlength='3'
     value='{@bottomRightCorner}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label><u>B</u>ottom right corner</label>
     <hint>The character code for the bottom right corner of a box</hint>
    </gjs:input>

    <gjs:input
     id='topT'
     accesskey='T'
     size='3'
     maxlength='3'
     value='{@topT}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label><u>T</u>op T</label>
     <hint>The character code for a T junction</hint>
    </gjs:input>

    <gjs:input
     id='bottomT'
     accesskey='B'
     size='3'
     maxlength='3'
     value='{@bottomT}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label><u>B</u>ottom T</label>
     <hint>The character code for an inverted T</hint>
    </gjs:input>

    <gjs:input
     id='leftT'
     accesskey='L'
     size='3'
     maxlength='3'
     value='{@leftT}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label><u>L</u>eft T</label>
     <hint>The character code for a left side T</hint>
    </gjs:input>

    <gjs:input
     id='rightT'
     accesskey='R'
     size='3'
     maxlength='3'
     value='{@rightT}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label><u>R</u>ight T</label>
     <hint>The character code for a right side T</hint>
    </gjs:input>

    <gjs:input
     id='cross'
     accesskey='R'
     size='3'
     maxlength='3'
     value='{@cross}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label>C<u>r</u>oss</label>
     <hint>The character code for a cross</hint>
    </gjs:input>

    <gjs:input
     id='downArrow'
     accesskey='A'
     size='3'
     maxlength='3'
     value='{@downArrow}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label>Down <u>a</u>rrow</label>
     <hint>The character code for a down arrow (V)</hint>
    </gjs:input>

    <tr><td height='16'></td></tr>
    <tr><td colspan='2'>Enter any escape sequence required to switch to or from graphics mode:</td></tr>
    <gjs:input
     id='setGraphicsMode'
     accesskey='G'
     size='60'
     maxlength='200'
     value='{@setGraphicsMode}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label>Set <u>g</u>raphics mode</label>
     <hint>An escape sequence to switch the device to a graphics character set or code page</hint>
    </gjs:input>

    <gjs:input
     id='setTextMode'
     accesskey='X'
     size='60'
     maxlength='200'
     value='{@setTextMode}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label>Set te<u>x</u>t mode</label>
     <hint>An escape sequence to switch the device to a text character set or code page</hint>
    </gjs:input>

    <tr><td height='16'></td></tr>

    <gjs:input
     id='initialisationExecuteCode'
     accesskey='I'
     size='60'
     maxlength='200'
     value='{@initialisationExecuteCode}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label><u>I</u>nitialization M code</label>
     <hint>M code to execute to initialise the device before starting to print</hint>
    </gjs:input>

    <gjs:input
     id='initialisationEscapeSequence'
     accesskey='N'
     size='60'
     maxlength='200'
     value='{@initialisationEscapeSequence}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label>I<u>n</u>itialization escape sequence</label>
     <hint>An escape sequence to initialize the device before starting to print</hint>
    </gjs:input>

    <gjs:input
     id='terminationEscapeSequence'
     accesskey='E'
     size='60'
     maxlength='200'
     value='{@terminationEscapeSequence}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label>T<u>e</u>rmination escape sequence</label>
     <hint>An escape sequence to reset the device after printing is complete</hint>
    </gjs:input>

  </gjs:fields>

  <gjs:inputHidden id='revision' value='{@revision}'/>
  <gjs:inputHidden id='oldDevice' value='{@device}'/>

  </gjs:frame>
</div>
</gjs:form>
</xsl:template>

</xsl:stylesheet>
