<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">

<xsl:include href='gjsForm.xsl'/>

<xsl:template match="Form">
  <xsl:apply-templates select="diffFuncSet"/>
</xsl:template>

<xsl:template match="diffFuncSet">

<gjs:form
 title='Diff Function Setting'
 jsFile='vcset77.js'
 onload='frmMain.diffCommand.focus();'
 save='{/Form/@save}'
 delete='no'
 close='{/Form/@close}'
 print='{/Form/@print}'
 help='{/Form/@help}'
 ok='{/Form/@ok}'
 cancel='{/Form/@cancel}'>

  <gjs:information>
    Settings for the terminal Diff function.
  </gjs:information>

<div id='divdiffFuncSet' class='visible' style='height: 200'>
  <gjs:frame>
  <!-- Set up frame column widths -->
  <gjs:columnWidths>
    <gjs:column width='200'/>
    <gjs:column width='220'/>
  </gjs:columnWidths>

  <gjs:fields>


    <gjs:input
     id='diffCommand'
     size='40'
     maxlength='2000'
     value='{@diffCommand}'
     onchange='Form.fnChanged()'
     accesskey='V'
     readonly='0'>
     <label>Ser<u>v</u>er OS file-compare command</label>
     <hint>Enter a command</hint>
    </gjs:input>

    <tr><td height='10'></td></tr>

    <gjs:input
     id='FDCompare10'
     size='40'
     maxlength='2000'
     value='{@FDCompare10}'
     onchange='Form.fnChanged()'
     accesskey='A'
     readonly='0'>
     <label>Default compare <u>a</u>rguments</label>
     <hint>Enter argument</hint>
    </gjs:input>

    <tr><td height='10'></td></tr>

    <gjs:input
     id='FDCompare20'
     size='40'
     maxlength='2000'
     value='{@FDCompare20}'
     onchange='Form.fnChanged()'
     accesskey='R'
     readonly='0'>
     <label>Di<u>r</u>ectory for scratch file</label>
     <hint>Enter a directory</hint>
    </gjs:input>

    <tr><td height='10'></td></tr>

    <gjs:input
     id='FDCompare30'
     size='40'
     maxlength='2000'
     value='{@FDCompare30}'
     onchange='Form.fnChanged()'
     accesskey='F'
     readonly='0'>
     <label>Pre<u>f</u>ix for scratch file</label>
     <hint>Enter prefix</hint>
    </gjs:input>

    <tr><td height='10'></td></tr>

    <xsl:apply-templates select="/Form/diffFuncSet/checkbox" mode='grid'>
                <xsl:with-param name='name'/>
		<xsl:with-param name='value'/>
              </xsl:apply-templates>


  </gjs:fields>


  <gjs:inputHidden id='revision' value='{@revision}'/>
 

  </gjs:frame>
</div>
</gjs:form>
</xsl:template>


<xsl:template match='checkbox' name='checkbox' mode="grid">
  <xsl:param name='checkbox'/>
     <td><label><xsl:value-of select='@label'/></label></td>
     <td>
      <xsl:choose>
        <xsl:when test='@value="1"'>
          <input 
           type='checkbox'
           id='{@name}'
           name='{@name}'
	   accesskey='I'
           onclick='Form.fnChanged()'
           checked='checked' />
        </xsl:when>
        <xsl:otherwise>
          <input 
           type='checkbox'
           id='{@name}'
  	   accesskey='I'
           onclick='Form.fnChanged()'
           name='{@name}' />
        </xsl:otherwise>
      </xsl:choose>
    </td>
</xsl:template>


</xsl:stylesheet>
