<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">

<xsl:include href='gjsForm.xsl'/>

<xsl:template match="Form">
  <xsl:apply-templates select="integrityChecker"/>
</xsl:template>

<xsl:template match="integrityChecker">

<gjs:form
 title='Integrity Checker'
 jsFile='vc433.js'
 onload='frmMain.vcpal.focus();'
 save='{/Form/@save}'
 close='{/Form/@close}'
 delete='no'
 print='no'
 help='{/Form/@help}'
 ok='{/Form/@ok}'
 cancel='{/Form/@cancel}'>

  <gjs:information>
    Integrity checker validates the consistency of data within the Deltanji repository. It runs in the background and logs audit messages under the pseudo-object vcm$integrity/vcm.
  </gjs:information>

 <div id='divIntegrityChecker' class='visible' style='min-height: 200px;'>
  <gjs:frame>
  <!-- Set up frame column widths -->
  <gjs:columnWidths>
    <gjs:column width='240'/>
    <gjs:column width='60'/>
    <gjs:column width='240'/>
    <gjs:column width='60'/>
    <gjs:column width='30'/>
  </gjs:columnWidths>


  <gjs:fields>
    
    <tr>
      <gjs:radio
        id='allobjects'
        name='allobjects' 
        value='1'
        accesskey='A'
        onclick='fnOnClick(this.value)'
        row='0'>
	      <xsl:if test='@chkAllOrSelected="1"'>
	        <xsl:attribute name="checked">checked</xsl:attribute>
	      </xsl:if>
	      <label>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<u>A</u>ll objects</label>
	      <hint>Perform checks on all objects</hint>
      </gjs:radio>
      <td></td>
      <td></td>
      <td></td>
    </tr>
    <tr>
      <gjs:radio
        id='allobjects'
        name='allobjects' 
        value='0'
        accesskey='S'
        onclick='fnOnClick(this.value)'
        row='0'>
        <xsl:if test='@chkAllOrSelected=""'>
          <xsl:attribute name="checked">checked</xsl:attribute>
        </xsl:if>
        <label>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<u>S</u>elected objects</label>
        <hint>Perform checks only on objects specified in the object selection fields below. Some checks are not available</hint>
      </gjs:radio>
      <td></td>
      <td></td>
      <td></td>
    </tr>

    <tr><td colspan='5' height='5'></td></tr>

    <tr>
      <td colspan='5'>
        <table class='formLayoutTable'>
          <tr>
            <gjs:column width='3'/>
            <gjs:column width='210'/>
            <gjs:column width='47'/>
            <gjs:column width='170'/>
            <gjs:column width='10'/>
          </tr>           
        </table>
      </td>
    </tr>
    <tr>
      <td colspan='4'>
        <div class='gridTableOuter' style='width: 600px;'>
          <div class='gridTableInner' style='height: 100px;' id='divObjectSelection'>
            <table class='formLayoutTable' cellSpacing='3' id='objSelect'>
              <tr>
                <gjs:column width='3'/>
                <gjs:column width='210'/>
                <gjs:column width='50'/>
                <gjs:column width='250'/>
                <gjs:column width='70'/>
              </tr>
              <tr valign='top'>
                <td></td>
                <gjs:caption for='selobv' accesskey='J'><label>Ob<u>j</u>ect</label></gjs:caption>
                <td></td>
                <gjs:caption for='obvs' accesskey='S'><label><u>S</u>election Criteria</label></gjs:caption>
                <td></td>
              </tr> 
              <tr>
                <td></td>
                <gjs:input row='0'
                  id='selobv'
                  size='30'
                  name='selobv'
                  style='width: 190px;'
                  maxlength='210'
                  title='Selection can be made using wildcards. If you wish to exclude objects from selection use the "-" operator.'
                  onchange='Form.fnChanged()'>
                  <xsl:if test='@chkAllOrSelected="1"'>
                    <xsl:attribute name="class">inputDisabled</xsl:attribute>
                    <xsl:attribute name="disabled">true</xsl:attribute>
                  </xsl:if>
                </gjs:input>  		

                <td>
                  <input
                    class='button'
                    type='button'
                    id='addObject'
                    name='addObject'
                    onclick='fnAddObject(frmMain.selobv)' 
                    title='Append contents of selection field to Selection Criteria list '
                    value='Add'>
                    <xsl:if test='@chkAllOrSelected="1"'>
                      <xsl:attribute name="disabled">true</xsl:attribute>
                    </xsl:if>
                  </input>
                </td>

                <td>
                  <select
                    name='obvs'
                    id='obvs'
                    style='width: 250px;'
                    size='4'
                    multiple='multiple'
                    title='Selection criteria that are applied in sequence to obtain the set of objects for checking'>
                    <xsl:if test='@chkAllOrSelected="1"'>
                      <xsl:attribute name="class">inputDisabled</xsl:attribute>
                      <xsl:attribute name="disabled">true</xsl:attribute>
                    </xsl:if>
                    <option>&nbsp;</option>
              	  </select>
                </td>

                <td>
                  <input
                    class='button'
                    type='button'
                    id='delObject'
                    name='delObject'
                    onclick='fnDelObject()' 
                    value='Remove'
                    title='Remove selected row(s) from Selection Criteria list'>
                    <xsl:if test='@chkAllOrSelected="1"'>
                      <xsl:attribute name="disabled">true</xsl:attribute>
                    </xsl:if>
                  </input>
                </td>
              </tr>
              <tr valign='top' align='right' id='counter'>
                <td></td>
                <td align='left' id="objCount">
                  <label>0 objects selected</label>
                </td>
                <td></td>
                <td></td>
                <td></td>
              </tr>
            </table>
          </div>
        </div>
      </td>
      <td></td>
    </tr>


    <tr><td colspan='5' height='5'></td></tr>
    
    <tr><td colspan='5'><label><u>V</u>ersion at location</label></td></tr>
		
    <tr>
      <gjs:radio
        id='vcal'
        name='vcal' 
        value='No'
        accesskey='V'
        onclick='fnOnClick(this.value)'
        row='0'>
        <xsl:if test='@chkVerAtLoc="No"'>
          <xsl:attribute name="checked">checked</xsl:attribute>
        </xsl:if>
        <label>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;No</label>
        <hint>Do not check version at location records</hint>
      </gjs:radio>
       
      <gjs:checkbox
        id='vcob'
        name='vcob'
        accesskey='D'
        onChange="Form.fnChanged()"
        row='0'>
        <xsl:if test='@chkObjDefinitions="1"'>
          <xsl:attribute name="checked">checked</xsl:attribute>
        </xsl:if>
        <label>Object <u>d</u>efinitions</label>
        <hint>Check object, variant and version records, ancestry and master location. Detect invalid or missing entries</hint>
      </gjs:checkbox>
      <td></td>
    </tr>
    
    <tr>
      <gjs:radio
        id='vcal'
        name='vcal' 
        value='Yes'
        accesskey='V'
        onclick='fnOnClick(this.value)'
        row='0'>
        <xsl:if test='@chkVerAtLoc="Yes"'>
          <xsl:attribute name="checked">checked</xsl:attribute>
        </xsl:if>
        <label>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Yes</label>
        <hint>Check records of which object versions are active where, and what components are present. Detect missing index entries for these records</hint>
      </gjs:radio>

      <gjs:checkbox
        id='vcal1'
        name='vcal1'
        accesskey='V'
        onChange="Form.fnChanged()"
        row='0'>
        <xsl:if test='@Index1="1"'>
          <xsl:attribute name="checked">checked</xsl:attribute>
        </xsl:if>
        <label>Version at location inde<u>x</u></label>
        <hint>Check index of locations at which an object version is present. Detect redundant entries</hint>
      </gjs:checkbox>
      <td></td>
    </tr>

    <tr>
      <gjs:radio
        id='vcal'
        name='vcal' 
        value='YesAndExists'
        accesskey='V'
        onclick='fnOnClick(this.value),fnPopWarning()'
        row='0'>
        <xsl:if test='@chkVerAtLoc="YesAndExists"'>
          <xsl:attribute name="checked">checked</xsl:attribute>
        </xsl:if>
        <label>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Yes, and check existence of components</label>
        <hint>Also check physical existence of components at locations. This may take a long time</hint>
      </gjs:radio>
       
      <gjs:checkbox
        id='vcch'
        name='vcch'
        accesskey='R'
        onChange="Form.fnChanged()"
        row='0'>
        <xsl:if test='@chkChReqTable="1"'>
          <xsl:attribute name="checked">checked</xsl:attribute>
        </xsl:if>
        <label>Change <u>r</u>equests of objects</label>
        <hint>Check change request index for objects. Detect missing entries</hint>
      </gjs:checkbox>
      <td></td>
    </tr>
    
    <tr>
      <td colspan='4'>
        <hr/>
      </td>
      <td></td>
    </tr>  

    <tr><td colspan='5'><label><b>All Objects</b></label></td></tr>

    <tr>
      <gjs:checkbox
        id='chreqi'
        name='chreqi'
        accesskey='G'
        onChange="Form.fnChanged()"
        row='0'>
        <xsl:if test='@chkChIndex="1"'>
          <xsl:attribute name="checked">checked</xsl:attribute>
        </xsl:if>
        <label>&nbsp;&nbsp;Chan<u>g</u>e requests with any members</label>
        <hint>Check contents of all change requests containing any object or nested change request. Detect missing items</hint>
      </gjs:checkbox>
      <gjs:checkbox
        id='vcli'
        name='vcli'
        accesskey='B'
        onChange="Form.fnChanged()"
        row='0'>
        <xsl:if test='@chkLibraries="1"'>
          <xsl:attribute name="checked">checked</xsl:attribute>
        </xsl:if>
        <label>&nbsp;&nbsp;Physical li<u>b</u>raries</label>
        <hint>Perform extensive consistency checking of objects and components in Deltanji native libraries (L-type)</hint>
      </gjs:checkbox>		
      <td></td>
    </tr>

    <tr>
      <gjs:checkbox
          id="vcpal"
          name="vcpal"
          accesskey="P"
          onChange="Form.fnChanged()"
          row='0'>
        <xsl:if test='@chkPhysAddLabels="1"'>
          <xsl:attribute name="checked">checked</xsl:attribute>
        </xsl:if>
        <label>&nbsp;&nbsp;<u>P</u>hysical address labels</label>
        <hint>Check presence of markers written by Deltanji to certain types of physical address</hint>
      </gjs:checkbox>

      <gjs:checkbox
        id='vcal2'
        name='vcal2'
        accesskey='L'
        onChange="Form.fnChanged()"
        row='0'>
        <xsl:if test='@Index2="1"'>
          <xsl:attribute name="checked">checked</xsl:attribute>
        </xsl:if>
        <label>&nbsp;&nbsp;<u>L</u>ocation by component index</label>
        <hint>Check index of locations at which each component is present. Detect redundant entries</hint> 
      </gjs:checkbox>
      <td></td>
    </tr>

    <tr>
      <gjs:checkbox
        id='vcal4'
        name='vcal4'
        accesskey='M'
        onChange="Form.fnChanged()"
        row='0'>
          <xsl:if test='@Index4="1"'>
            <xsl:attribute name="checked">checked</xsl:attribute>
          </xsl:if>
          <label>&nbsp;&nbsp;Co<u>m</u>ponent by location index</label>
          <hint>Check index of objects owning components at locations. Detect redundant and missing entries</hint>
      </gjs:checkbox>
   
      <gjs:checkbox
           id='vcal3'
           name='vcal3'
           accesskey='Y'
					 onChange="Form.fnChanged()"
					 row='0'>
           <xsl:if test='@Index3="1"'>
						 <xsl:attribute name="checked">checked</xsl:attribute>
					 </xsl:if>
					 <label>&nbsp;&nbsp;Routine b<u>y</u> version index</label>
					 <hint>Check index of locations and owning objects for all R-type components. Detect redundant entries</hint>
      </gjs:checkbox>
      <td></td>
    </tr>

    <tr>
      <td colspan='4'>
        <hr/>
      </td>
      <td></td>
    </tr>

    <tr>
      <gjs:checkbox
        id='fixit'
        name='fixit'
        onChange="Form.fnChanged()"
        row='0'>
          <xsl:if test='@fixit="1"'>
            <xsl:attribute name="checked">checked</xsl:attribute>
          </xsl:if>
          <label>Repair errors</label>
          <hint>Correct errors automatically if possible</hint>
			</gjs:checkbox>
      <td colspan='3'></td>
    </tr>

  </gjs:fields>

  <gjs:inputHidden id='revision' value='{@revision}'/>
  <gjs:inputHidden id='phys' value='{@phys}'/>

  </gjs:frame>
</div>
</gjs:form>
</xsl:template>




<!-- Object list boxes -->
<xsl:template match='objects' mode="list1">
  <item>
    <label><xsl:value-of select="@option" /></label>
    <value><xsl:value-of select="@option" /></value>
  </item>
</xsl:template>


</xsl:stylesheet>
