<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">

<xsl:include href='gjsForm.xsl'/>

<xsl:template match="Form">
  <xsl:apply-templates select="license"/>
</xsl:template>

<xsl:template match="license">

<gjs:form
 title='License Key'
 jsFile='vc0251.js'
 onload='frmMain.licenseNumber.focus();'>

  <gjs:information>
    Enter your license number and registration information exactly as it appears on your license certificate.
  </gjs:information>

<div id='divLicense' class='visible' style='min-height: 240px;'>
  <gjs:frame>
  <!-- Set up frame column widths -->
  <gjs:columnWidths>
    <gjs:column width='100'/>
    <gjs:column width='330'/>
  </gjs:columnWidths>

  <gjs:fields>

    <gjs:input
     id='fileLocation'
     accesskey='F'
     size='50'
     maxlength='200'
     value='{@fileLocation}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label>Key <u>f</u>ile location</label>
     <hint>The path to the location where the key file will be stored.  The file name vcm.key is not included here.</hint>
    </gjs:input>

    <gjs:input
     id='licenseNumber'
     accesskey='B'
     size='6'
     maxlength='6'
     value='{@licenseNumber}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label>License num<u>b</u>er</label>
     <hint>The unique license number identifier</hint>
    </gjs:input>

    <gjs:input
     id='customerName'
     accesskey='T'
     size='50'
     maxlength='200'
     value='{@customerName}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label>Licensed <u>t</u>o</label>
     <hint>The name of the customer</hint>
    </gjs:input>

    <tr>
      <td height='16'></td>
    </tr>

    <tr>
      <td></td>
      <td>
        <table class='formLayoutTable'>
              <tr>
                <td style='padding-left: 5;'></td>
                <gjs:column width='200'/>
                <gjs:column width='100'/>
              </tr>
              <tr>
                <td height='20' style='padding-left: 5;'></td>
                <gjs:caption><label>Option</label></gjs:caption>
                <gjs:caption><label>Value</label></gjs:caption>
              </tr>
        </table>
      </td>
    </tr>

    <tr>
      <gjs:caption for='option' accesskey='N'>
        <label>
          Optio<u>n</u>s
        </label>
      </gjs:caption>
      <td>
        <div class='gridTableOuter' style='min-height: 200px; min-width: 340px;'>
          <table class='formLayoutTable'>
          </table>
          <div class='gridTableInner' style='height: 200px;' id='divOptions'>
            <table class='formLayoutTable'>
              <tr>
                <gjs:column width='200'/>
                <gjs:column width='100'/>
              </tr>
              <xsl:call-template name='option'>
                <xsl:with-param name='style' select='"display: none;"'/>
                <xsl:with-param name='lastRow' select='"1"'/> <!-- sic -->
              </xsl:call-template>
              <xsl:apply-templates select='options/option' mode='grid'>
                <xsl:with-param name='style' select='""'/>
                <xsl:with-param name='lastRow' select='"0"'/>
              </xsl:apply-templates>
              <xsl:call-template name='option'>
                <xsl:with-param name='style' select='""'/>
                <xsl:with-param name='lastRow' select='"1"'/>
              </xsl:call-template>
            </table>
          </div>
        </div>
      </td>
    </tr>

    <tr>
      <td height='16'></td>
    </tr>

    <gjs:input
     id='licenseKey'
     accesskey='K'
     size='10'
     maxlength='10'
     value='{@licenseKey}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label>License <u>k</u>ey</label>
     <hint>The name of the customer</hint>
    </gjs:input>

  </gjs:fields>

  </gjs:frame>
</div>
</gjs:form>
</xsl:template>

<xsl:template match='option' name='option' mode='grid'>
  <xsl:param name='style'/>
  <xsl:param name='lastRow'/>
  <tr 
   style='{$style}'
   gjsLastRow='{$lastRow}'>
    <td style='padding-left: 5;'>
      <input 
       type='text' 
       size='26'
       id='optionName' 
       name='optionName' 
       value='{@option}' 
       onchange='Form.fnChanged()'
       class='input' />
    </td>
    <td>
      <input 
       type='text' 
       size='20'
       id='optionValue' 
       name='optionValue' 
       value='{@value}' 
       onchange='Form.fnChanged()'
       class='input' />
    </td>
  </tr>
</xsl:template>


</xsl:stylesheet>
