//vc/ VC/m Location Class
//vc/ Copyright 1999,2003 George James
//vc/ Object:    Location.js
//vc/ Component: T.Location.js


	// Location Class
Location = {}

Location.Current=Disabled;
Location.windowProperties  = 'left=50,top=50,width=735,height=560,toolbar=no';
Location.windowProperties += ',location=no,directories=no,status=yes,resizable=yes,menubar=no';
Location.labelWindowProperties  = 'left=50,top=50,width=550,height=400,toolbar=no';
Location.labelWindowProperties += ',location=no,directories=no,status=yes,resizable=yes,menubar=no';


	// Public - Display List of locations and make this the active folder
Location.fnList = function() {
	//
	SelectedClass=Location
	Class.fnUnselect()
	//
	ServerLink.fnDo('Location.fnListResult','Location.fnList','')
}

Location.fnListResult = function(oResult) {
	//
  // Copy results from oResult to document
  ServerLink.fnUpdate(oResult,'divFolderHeadingCaption')
  ServerLink.fnUpdate(oResult,'divMainBody')
  ServerLink.fnUpdate(oResult,'divMainHead')
}

	// Private - Invoked when an item is selected on the list
Location.fnSelect = function(oCell) {
	Class.fnSelect(Location,oCell);
}


	// Public - Open new location window
Location.fnNew = function() {
	fnRunWindow("Location.fnNew",Location.windowProperties); 
}

	// Public - Open location
Location.fnOpen = function(sLocation) {
	var url
	//
	// Build url string
	url  = parent.serverUrl
	url += '&page=' + escape('Location.fnOpen')
	url += '&selectedItem=' + encodeURIComponent(sLocation)
	//
	// Open location window
	winLocation=window.open(url,'_blank',Location.windowProperties)
	winLocation.focus()
}

// Public - Fork a derived Location so it becomes an ordinary one
Location.fnFork = function(sLocation) {
	var arguments;
	//
	if (!confirm("Are you sure you want to fork \'"+sLocation+"\' to make it independent of the template which originally derived it?")) return;
	//
	arguments = sLocation;
	//
	parent.serverLink.fnDo('Location.fnForkResult','Location.fnFork',arguments);
}

Location.fnForkResult = function(result) {
	if (result!="OK") {
		alert(result);
		return;
	}
	fnRefreshSelected();
}

	// Public - Yield an underived Location so a template save can overwrite it and make it a derived one.
Location.fnYield = function(sLocation) {
	var arguments;
	//
	if (!confirm("Yielding \'"+sLocation+"\' will permit it to be overwritten the next time a template definition which targets it generates derivatives.\n\nThe yield will cease if this definition is edited before such a derivation happens.\n\nDo you want to proceed?")) return;
	//
	arguments = sLocation;
	//
	parent.serverLink.fnDo('Location.fnYieldResult','Location.fnYield',arguments);
}

Location.fnYieldResult = function(result) {
	if (result!="OK") {
		alert(result);
		return;
	}
	fnRefreshSelected();
}
	
	// Public - Copy location
Location.fnCopy = function(sLocation) {
	var url
	//
	// Build url string
	url  = parent.serverUrl
	url += '&page=' + escape('Location.fnCopy')
	url += '&selectedItem=' + encodeURIComponent(sLocation)
	//
	// Open location window
	winLocation=window.open(url,'_blank',Location.windowProperties)
	winLocation.focus()
}

	// Public - Delete a location
Location.fnDelete = function(sLocation) {
	var arguments;
	//
	if (!confirm("Are you sure you want to delete location \'"+sLocation+"\' ?")) return;
	//
	arguments = sLocation;
	//
	parent.serverLink.fnDo('Location.fnDeleteResult','Location.fnDelete',arguments);
}

Location.fnDeleteResult = function(result) {
	if (result!="OK") {
		alert(result);
		return;
	}
	fnRefreshSelected();

}

  // Refresh Location
Location.fnRefreshArguments = function(oMain)   {
  //
	var arguments=""
	//
  arguments +=          getAttr(oMain,'gjsParentId')
  arguments += '\002' + gjsTree.fnMores(fnElement(getAttr(oMain,'gjsRowId')+'click').previousElementSibling)
	arguments += '\002' + getAttr(oMain,'gjsItem')
	arguments += '\002' + getAttr(oMain,'gjsRowId')
	arguments += '\002' + getAttr(fnElement(getAttr(oMain,'gjsRowId')+'body').parentNode,'gjsReferenceHeadingId')
	//
	return arguments
}

Location.fnRefresh = function(arguments)   {
  //
  ServerLink.fnDo('Location.fnRefreshResult','Location.fnRefresh',arguments)
}

Location.fnRefreshResult = function(oResult) {
  gjsTree.fnRefreshRows("divMainBody",oResult)
  gjsTree.fnDeleteRows("divRowDelete",oResult)
}

	// Public - Open dialog to create a new label from a location
Location.fnNewLabel = function(sLocation) {
	var url
	//
	// Build url string
	url  = parent.serverUrl
	url += '&page=' + escape('Location.Label.fnNew')
	url += '&selectedItem=' + encodeURIComponent(sLocation)
	//
	// Open label window
	winLocation=window.open(url,'_blank',Location.labelWindowProperties)
	winLocation.focus()
}


Location.Item = {

 fnFork: function() {
	if (typeof(Location.Current)=='undefined') return;
	Location.fnFork(getAttr(Location.selectedCell,'gjsItem'));
 },

 fnYield: function() {
	if (typeof(Location.Current)=='undefined') return;
	Location.fnYield(getAttr(Location.selectedCell,'gjsItem'));
 },

 fnDelete: function() {
	if (typeof(Location.Current)=='undefined') return;
	Location.fnDelete(getAttr(Location.selectedCell,'gjsItem'));
 },
 
	// Public - open selected location (if there is one)
 fnOpen: function() {
	if (typeof(Location.Current)=='undefined') return;
	Location.fnOpen(getAttr(Location.selectedCell,'gjsItem'));
 },
 
	// Public - copy selected location (if there is one)
 fnCopy: function() {
	if (typeof(Location.Current)=='undefined') return;
	Location.fnCopy(getAttr(Location.selectedCell,'gjsItem'));
 }
}

