//vc/ VC/m Location List (formerly Location Class) Class
//vc/ Copyright 1999,2003 George James
//vc/ Object:    LocationClass.js
//vc/ Component: T.LocationClass.js


	// Location list Class
LocationClass = {}

LocationClass.Current=Disabled;
LocationClass.windowProperties  = 'left=50,top=50,width=400,height=400,toolbar=no';
LocationClass.windowProperties += ',location=no,directories=no,status=yes,resizable=yes,menubar=no';


	// Public - Display List of location lists and make this the active folder
LocationClass.fnList = function() {
	//
	SelectedClass=LocationClass
	Class.fnUnselect()
	//
	ServerLink.fnDo('LocationClass.fnListResult','LocationClass.fnList','')
}

LocationClass.fnListResult = function(oResult) {
	//
  // Copy results from oResult to document
  ServerLink.fnUpdate(oResult,'divFolderHeadingCaption')
  ServerLink.fnUpdate(oResult,'divMainBody')
  ServerLink.fnUpdate(oResult,'divMainHead')
}

	// Private - Invoked when an item is selected on the list
LocationClass.fnSelect = function(oCell) {
	Class.fnSelect(LocationClass,oCell);
}

	// Public - Open new location list window
LocationClass.fnNew = function() {
	fnRunWindow("LocationClass.fnNew",LocationClass.windowProperties); 
}

	// Public - Open location list
LocationClass.fnOpen = function(sLocationClass) {
	;
	var url;
	;
	// Build url string
	url  = parent.serverUrl ;
	url += '&page=' + escape('LocationClass.fnOpen') ;
	url += '&selectedItem=' + encodeURIComponent(sLocationClass) ;
	;
	// Open location list window
	winLocationClass=window.open(url,'_blank',LocationClass.windowProperties) ;
	winLocationClass.focus();
}

	// Public - Fork a derived Location List so it becomes an ordinary one
LocationClass.fnFork = function(sLocationClass) {
	var arguments;
	//
	if (!confirm("Are you sure you want to fork \'"+sLocationClass+"\' to make it independent of the template which originally derived it?")) return;
	//
	arguments = sLocationClass;
	//
	parent.serverLink.fnDo('LocationClass.fnForkResult','LocationClass.fnFork',arguments);
}

LocationClass.fnForkResult = function(result) {
	if (result!="OK") {
		alert(result);
		return;
	}
	fnRefreshSelected();
}

	// Public - Yield an underived Location List so a template save can overwrite it and make it a derived one.
LocationClass.fnYield = function(sLocationClass) {
	var arguments;
	//
	if (!confirm("Yielding \'"+sLocationClass+"\' will permit it to be overwritten the next time a template definition which targets it generates derivatives.\n\nThe yield will cease if this definition is edited before such a derivation happens.\n\nDo you want to proceed?")) return;
	//
	arguments = sLocationClass;
	//
	parent.serverLink.fnDo('LocationClass.fnYieldResult','LocationClass.fnYield',arguments);
}

LocationClass.fnYieldResult = function(result) {
	if (result!="OK") {
		alert(result);
		return;
	}
	fnRefreshSelected();
}
	
	// Public - Delete a location list
LocationClass.fnDelete = function(sLocationClass) {
	;
	var arguments;
	;
	if (!confirm("Are you sure you want to delete location list \'"+sLocationClass+"\' ?")) return;
	;
	arguments = sLocationClass;
	;
	parent.serverLink.fnDo('LocationClass.fnDeleteResult','LocationClass.fnDelete',arguments);
}

LocationClass.fnDeleteResult = function(result) {
	if (result!="OK") {
		alert(result);
		return;
	}
	fnRefreshSelected();
}


  // Refresh LocationClass
LocationClass.fnRefreshArguments = function(oMain)   {
  //
	var arguments=""
	//
  arguments +=          getAttr(oMain,'gjsParentId')
  arguments += '\002' + gjsTree.fnMores(fnElement(getAttr(oMain,'gjsRowId')+'click').previousElementSibling)
	arguments += '\002' + getAttr(oMain,'gjsItem')
	arguments += '\002' + getAttr(oMain,'gjsRowId')
	arguments += '\002' + getAttr(fnElement(getAttr(oMain,'gjsRowId')+'body').parentNode,'gjsReferenceHeadingId')
	//
	return arguments
}

LocationClass.fnRefresh = function(arguments)   {
  //
  ServerLink.fnDo('LocationClass.fnRefreshResult','LocationClass.fnRefresh',arguments)
}

LocationClass.fnRefreshResult = function(oResult) {
  gjsTree.fnRefreshRows("divMainBody",oResult)
  gjsTree.fnDeleteRows("divRowDelete",oResult)
}

LocationClass.Item = {

 fnFork: function() {
	if (typeof(LocationClass.Current)=='undefined') return;
	LocationClass.fnFork(getAttr(LocationClass.selectedCell,'gjsItem'));
 },

 fnYield: function() {
	if (typeof(LocationClass.Current)=='undefined') return;
	LocationClass.fnYield(getAttr(LocationClass.selectedCell,'gjsItem'));
 },

 fnDelete: function() {
	if (typeof(LocationClass.Current)=='undefined') return;
	LocationClass.fnDelete(getAttr(LocationClass.selectedCell,'gjsItem'));
 },
 
	// Public - open selected location list (if there is one)
 fnOpen: function() {
	if (typeof(LocationClass.Current)=='undefined') return;
	LocationClass.fnOpen(getAttr(LocationClass.selectedCell,'gjsItem'));
 }
}

