//vc/ VC/m Location class Class
//vc/ Copyright 1999,2002 George James
//vc/ Object:    Class.js
//vc/ Component: T.System.js


	// System Class
System = {}

System.Current=Disabled;
System.windowProperties  = 'left=50,top=50,width=400,height=400,toolbar=no';
System.windowProperties += ',location=no,directories=no,status=yes,resizable=yes,menubar=no';

	// Public - Display List of systems and make this the active folder
System.fnList = function() {
	//
	SelectedClass=System
	Class.fnUnselect()
	//
	ServerLink.fnDo('System.fnListResult','System.fnList','')
}

System.fnListResult = function(oResult) {
	//
  // Copy results from oResult to document
  ServerLink.fnUpdate(oResult,'divFolderHeadingCaption')
  ServerLink.fnUpdate(oResult,'divMainBody')
  ServerLink.fnUpdate(oResult,'divMainHead')
}

	// Private - Invoked when an item is selected on the list
System.fnSelect = function(oCell) {
	Class.fnSelect(System,oCell);
}

	// Public - Open new system window
System.fnNew = function() {
	fnRunWindow("System.fnNew",System.windowProperties); 
}

	// Public - Open System
System.fnOpen = function(sSystem) {
	var url;
	//
	// Build url string
	url  = parent.serverUrl ;
	url += '&page=' + escape('System.fnOpen') ;
	url += '&selectedItem=' + encodeURIComponent(sSystem) ;
	//
	// Open system window
	winSystem=window.open(url,'_blank',System.windowProperties) ;
	winSystem.focus();
}

	// Public - Fork a derived System so it becomes an ordinary one
System.fnFork = function(sSystem) {
	var arguments;
	//
	if (!confirm("Are you sure you want to fork \'"+sSystem+"\' to make it independent of the template which originally derived it?")) return;
	//
	arguments = sSystem;
	//
	parent.serverLink.fnDo('System.fnForkResult','System.fnFork',arguments);
}

System.fnForkResult = function(result) {
	if (result!="OK") {
		alert(result);
		return;
	}
	fnRefreshSelected();
}

	// Public - Yield an underived System so a template save can overwrite it and make it a derived one.
System.fnYield = function(sSystem) {
	var arguments;
	//
	if (!confirm("Yielding \'"+sSystem+"\' will permit it to be overwritten the next time a template definition which targets it generates derivatives.\n\nThe yield will cease if this definition is edited before such a derivation happens.\n\nDo you want to proceed?")) return;
	//
	arguments = sSystem;
	//
	parent.serverLink.fnDo('System.fnYieldResult','System.fnYield',arguments);
}

System.fnYieldResult = function(result) {
	if (result!="OK") {
		alert(result);
		return;
	}
	fnRefreshSelected();
}
	
	// Public - Delete a location System
System.fnDelete = function(sSystem) {
	var arguments;
	//
	if (!confirm("Are you sure you want to delete system \'"+sSystem+"\' ?")) return;
	//
	arguments = sSystem;
	//
	parent.serverLink.fnDo('System.fnDeleteResult','System.fnDelete',arguments);
}

System.fnDeleteResult = function(result) {
	if (result!="OK") {
		alert(result);
		return;
	}
	fnRefreshSelected();
}

  // Refresh System
System.fnRefreshArguments = function(oMain)   {
  //
	var arguments=""
	//
  arguments +=          getAttr(oMain,'gjsParentId')
  arguments += '\002' + gjsTree.fnMores(fnElement(getAttr(oMain,'gjsRowId')+'click').previousElementSibling)
	arguments += '\002' + getAttr(oMain,'gjsItem')
	arguments += '\002' + getAttr(oMain,'gjsRowId')
	arguments += '\002' + getAttr(fnElement(getAttr(oMain,'gjsRowId')+'body').parentNode,'gjsReferenceHeadingId')
	//
	return arguments
}

System.fnRefresh = function(arguments)   {
  //
  ServerLink.fnDo('System.fnRefreshResult','System.fnRefresh',arguments)
}

System.fnRefreshResult = function(oResult) {
  gjsTree.fnRefreshRows("divMainBody",oResult)
  gjsTree.fnDeleteRows("divRowDelete",oResult)
}


System.Item = {

 fnFork: function() {
	if (typeof(System.Current)=='undefined') return;
	System.fnFork(getAttr(System.selectedCell,'gjsItem'));
 },

 fnYield: function() {
	if (typeof(System.Current)=='undefined') return;
	System.fnYield(getAttr(System.selectedCell,'gjsItem'));
 },

 fnDelete: function() {
	if (typeof(System.Current)=='undefined') return;
	System.fnDelete(getAttr(System.selectedCell,'gjsItem'));
 },
 
	// Public - open selected location system (if there is one)
 fnOpen: function() {
	if (typeof(System.Current)=='undefined') return;
	System.fnOpen(getAttr(System.selectedCell,'gjsItem'));
 }
}
