<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet 
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">

<!-- TransferRoute List
     =============
-->

<xsl:import href='gjsTree.xsl' />
<xsl:include href='ServerLink.xsl' />


<xsl:template match="/ServerLink/Rows">
  <div id='divFolderHeadingCaption'>
    Transfer Routes
  </div>
  <div id='divMainHead'>
    <xsl:call-template name='divMainHead' />
  </div>
  <xsl:call-template name='gjs:tree' />
</xsl:template>


<xsl:template name='divMainHead'>

  	<table class='layoutTable' width='2000px' gjsTreeId='TransferRoute_List'>
  	  <tr>

        <xsl:call-template name='gjs:treeMoresMainHeading' />

        <td width='25'></td>

        <xsl:call-template name='gjs:treeColumnHeading'>
          <xsl:with-param name='width' select='"80"'/>
          <xsl:with-param name='columnId'>Function</xsl:with-param>
          <xsl:with-param name='caption'>Function</xsl:with-param>         
          <xsl:with-param name='selected'>ascending</xsl:with-param>
					<xsl:with-param name='previousColumnResizable'>0</xsl:with-param>
        </xsl:call-template>
  	    
        <xsl:call-template name='gjs:treeColumnHeading'>
          <xsl:with-param name='width' select='"80"'/> 
          <xsl:with-param name='columnId'>From</xsl:with-param> 
          <xsl:with-param name='caption'>From</xsl:with-param>         
        </xsl:call-template>
  	    
        <xsl:call-template name='gjs:treeColumnHeading'>
          <xsl:with-param name='width' select='"80"'/> 
          <xsl:with-param name='columnId'>To</xsl:with-param> 
          <xsl:with-param name='caption'>To</xsl:with-param>         
        </xsl:call-template>
  	    
        <xsl:call-template name='gjs:treeColumnHeading'>
          <xsl:with-param name='width' select='"100"'/> 
          <xsl:with-param name='columnId'>AccessCodes</xsl:with-param> 
          <xsl:with-param name='caption'>Access Rights</xsl:with-param>         
          <xsl:with-param name='title'>Struck-through access rights indicate disabled route</xsl:with-param>         
        </xsl:call-template>

        <xsl:call-template name='gjs:treeColumnHeading'>
          <xsl:with-param name='width' select='"200"'/> 
          <xsl:with-param name='columnId'>DependentLocations</xsl:with-param> 
          <xsl:with-param name='caption'>Dependencies</xsl:with-param>         
        </xsl:call-template>
  	    
        <xsl:call-template name='gjs:treeColumnHeading'>
          <xsl:with-param name='width' select='"200"'/> 
          <xsl:with-param name='columnId'>NewActiveLocations</xsl:with-param> 
          <xsl:with-param name='caption'>Activations</xsl:with-param>
        </xsl:call-template>
  	    
        <xsl:call-template name='gjs:treeColumnHeading'>
          <xsl:with-param name='width' select='"80"'/> 
          <xsl:with-param name='columnId'>MasterLocation</xsl:with-param> 
          <xsl:with-param name='caption'>Master</xsl:with-param>         
        </xsl:call-template>
  	    
        <xsl:call-template name='gjs:treeColumnHeading'>
          <xsl:with-param name='width' select='"50"'/> 
          <xsl:with-param name='columnId'>TransferType</xsl:with-param> 
          <xsl:with-param name='caption'>Type</xsl:with-param>         
        </xsl:call-template>
  	    
        <xsl:call-template name='gjs:treeColumnHeading'>
          <xsl:with-param name='width' select='"50"'/> 
          <xsl:with-param name='columnId'>NewVersion</xsl:with-param> 
          <xsl:with-param name='caption'>New?</xsl:with-param>         
        </xsl:call-template>
  	    
        <xsl:call-template name='gjs:treeColumnHeading'>
          <xsl:with-param name='width' select='"200"'/> 
          <xsl:with-param name='columnId'>Message</xsl:with-param> 
          <xsl:with-param name='caption'>Message</xsl:with-param>         
        </xsl:call-template>
  	    
        <xsl:call-template name='gjs:treeColumnHeading'>
          <xsl:with-param name='width' select='"100"'/> 
          <xsl:with-param name='columnId'>Category</xsl:with-param> 
          <xsl:with-param name='caption'>Category</xsl:with-param>         
        </xsl:call-template>
  	    
        <xsl:call-template name='gjs:treeColumnHeading'>
          <xsl:with-param name='width' select='"100"'/> 
          <xsl:with-param name='columnId'>SkipCategory</xsl:with-param> 
          <xsl:with-param name='caption'>SkipCat</xsl:with-param>         
        </xsl:call-template>
  	    
        <xsl:call-template name='gjs:treeColumnHeading'>
          <xsl:with-param name='width' select='"100"'/> 
          <xsl:with-param name='columnId'>ErrorCategory</xsl:with-param> 
          <xsl:with-param name='caption'>ErrCat</xsl:with-param>         
        </xsl:call-template>
  	    
        <xsl:call-template name='gjs:treeColumnHeading'>
          <xsl:with-param name='width' select='"65"'/> 
          <xsl:with-param name='columnId'>Sequence</xsl:with-param> 
          <xsl:with-param name='caption'>Sequence?</xsl:with-param>         
        </xsl:call-template>
  	    
        <xsl:call-template name='gjs:treeColumnHeading'>
          <xsl:with-param name='width' select='"60"'/> 
          <xsl:with-param name='columnId'>Disabled</xsl:with-param> 
          <xsl:with-param name='caption'>Disabled?</xsl:with-param>         
        </xsl:call-template>
  	    
        <xsl:call-template name='gjs:treeColumnHeading'>
          <xsl:with-param name='width' select='"100"'/> 
          <xsl:with-param name='columnId'>BackupFunction</xsl:with-param> 
          <xsl:with-param name='caption'>Backup Function</xsl:with-param>         
        </xsl:call-template>
  	    
        <xsl:call-template name='gjs:treeColumnHeading'>
          <xsl:with-param name='width' select='"80"'/> 
          <xsl:with-param name='columnId'>BackupTo</xsl:with-param> 
          <xsl:with-param name='caption'>Backup To</xsl:with-param>         
        </xsl:call-template>
        
        <xsl:call-template name='gjs:treeColumnHeading'>
          <xsl:with-param name='width' select='"2000"'/> 
        </xsl:call-template>
  	    
        <td width='*'></td>
      </tr>
    </table>

</xsl:template>

<!-- Keep leafContent in sync with folderContent further down.
Most routes are displayed as leaves, but templates show as folders so their derivatives can be descended to -->
<xsl:template name='leafContent'>

  <xsl:variable name='from' select='route/@from'/>
  <xsl:variable name='to' select='route/@to'/>

  <!-- Icon for record -->
  <td class='noHighlight' width='25px'>
    <img
     width='25px'
     height='16px'>
    <xsl:choose>
      <xsl:when test='route/@isTemplate="1"'>
        <xsl:attribute name='src'>vcm_template_l.gif</xsl:attribute>
      </xsl:when>
      <xsl:when test='route/@genByKey!=""'>
        <xsl:attribute name='src'>vcm_derived_l.gif</xsl:attribute>
      </xsl:when>
      <xsl:otherwise>
        <xsl:attribute name='src'>vcm_record_l.gif</xsl:attribute>
      </xsl:otherwise>
    </xsl:choose>
    </img>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:value-of select='route/@function' />
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap' title='{/ServerLink/locations/location[@location=$from]/@description}'>
      <xsl:value-of select='$from' />
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap' title='{/ServerLink/locations/location[@location=$to]/@description}'>
      <xsl:value-of select='$to' />
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:value-of select='route/@accessCodes' />
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:value-of select='route/@dependentLocations' />
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:value-of select='route/@newActiveLocations' />
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:value-of select='route/@masterLocation' />
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:choose>
        <xsl:when test='route/@transferType="C"'>
          Copy
        </xsl:when>
        <xsl:when test='route/@transferType="M"'>
          Move
        </xsl:when>
        <xsl:otherwise>
          ??
        </xsl:otherwise>
      </xsl:choose>
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:choose>
        <xsl:when test='route/@newVersion="1"'>
          Yes
        </xsl:when>
        <xsl:when test='route/@newVersion="0"'>
          No
        </xsl:when>
        <xsl:otherwise>
          ??
        </xsl:otherwise>
      </xsl:choose>
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:value-of select='route/@message' />
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:value-of select='route/@categoryName' />
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:value-of select='route/@skipCategoryName' />
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:value-of select='route/@errorCategoryName' />
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:choose>
        <xsl:when test='route/@sequence="1"'>
          Yes
        </xsl:when>
        <xsl:when test='route/@sequence="0"'>
          No
        </xsl:when>
        <xsl:otherwise>
          ??
        </xsl:otherwise>
      </xsl:choose>
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:choose>
        <xsl:when test='route/@disabled="1"'>
          Yes
        </xsl:when>
        <xsl:when test='route/@disabled="0"'>
          No
        </xsl:when>
        <xsl:otherwise>
          ??
        </xsl:otherwise>
      </xsl:choose>
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:value-of select='route/@backupFunction' />
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:value-of select='route/@backupTo' />
    </div>
  </td>
</xsl:template>


<!-- Attributes for each leaf row. Keep in sync with folderRowAttributes further down -->
<xsl:template name='leafRowAttributes'>
	<xsl:param name='rowId'/>

  <!-- If this is an update then use the old divReferenceHeadingId otherwise use a new unique one -->
  <xsl:variable name='divReferenceHeadingId'>
    <xsl:choose>
      <xsl:when test='rowUpdate'>
        <xsl:value-of select='rowUpdate/@divReferenceHeadingId' />
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select='/ServerLink/@runId' />
        <xsl:text>_mainHead</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:variable>
  
  <xsl:attribute name='tabindex'>0</xsl:attribute>
  <xsl:attribute name='onfocus'>fnItemSelect(this);Class.fnSelect(TransferRoute,this);Main.fnSetMainHead("<xsl:value-of select='$divReferenceHeadingId' />");</xsl:attribute>
  <xsl:attribute name='onclick'>fnItemSelect(this);Class.fnSelect(TransferRoute,this)</xsl:attribute>
  <xsl:attribute name='gjsItem'><xsl:value-of select='route/@function' />|<xsl:value-of select='route/@from' />|<xsl:value-of select='route/@to' /></xsl:attribute>
  <xsl:attribute name='gjsReferenceHeadingId'><xsl:value-of select='$divReferenceHeadingId' /></xsl:attribute>
  <xsl:attribute name='id'><xsl:value-of select='$rowId' />main</xsl:attribute>
	<xsl:if test='/ServerLink/allowedMethods/method[@name="TransferRoute.fnOpen"]'>
		<xsl:attribute name='ondblclick'>TransferRoute.Item.fnOpen()</xsl:attribute>
	</xsl:if>
  <xsl:attribute name='oncontextmenu'>fnItemSelect(this);Class.fnSelect(TransferRoute,this);fnContextMenu("vcm.popDerivableItem")</xsl:attribute>
	<xsl:if test='route/@revision="-1" and route/@genByKey!=""'>
	  <xsl:attribute name='oncontextmenu'>fnItemSelect(this);Class.fnSelect(TransferRoute,this);fnContextMenu("vcm.popDerivedItem")</xsl:attribute>
	</xsl:if>
	<xsl:if test='route/@revision="-1" and route/@genByKey=""'>
	  <xsl:attribute name='oncontextmenu'>fnItemSelect(this);Class.fnSelect(TransferRoute,this);fnContextMenu("popItem")</xsl:attribute>
	</xsl:if>
	<xsl:if test='route/@genByKey!=""'>
		<xsl:attribute name='class'>disabledRow</xsl:attribute>
	</xsl:if>
	<xsl:if test='route/@disabled="1"'>
		<xsl:attribute name='style'>text-decoration: line-through;</xsl:attribute>
	</xsl:if>
</xsl:template>


<!-- Keep folderContent in sync with leafContent further up -->
<xsl:template name='folderContent'>
  <xsl:param name='rowId'/>

  <xsl:apply-templates select='route'>
    <xsl:with-param name='rowId' select='$rowId' />
	</xsl:apply-templates>
</xsl:template>


<!-- Attributes for each folder row. Keep in sync with leafRowAttributes further up -->
<xsl:template name='folderRowAttributes'>
	<xsl:param name='rowId'/>

  <!-- If this is an update then use the old divReferenceHeadingId otherwise use a new unique one -->
  <xsl:variable name='divReferenceHeadingId'>
    <xsl:choose>
      <xsl:when test='rowUpdate'>
        <xsl:value-of select='rowUpdate/@divReferenceHeadingId' />
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select='/ServerLink/@runId' />
        <xsl:text>_mainHead</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:variable>
  
  <xsl:attribute name='tabindex'>0</xsl:attribute>
  <xsl:attribute name='onfocus'>fnItemSelect(this);Class.fnSelect(TransferRoute,this);Main.fnSetMainHead("<xsl:value-of select='$divReferenceHeadingId' />");</xsl:attribute>
  <xsl:attribute name='onclick'>fnItemSelect(this);Class.fnSelect(TransferRoute,this)</xsl:attribute>
  <xsl:attribute name='oncontextmenu'>fnItemSelect(this);Class.fnSelect(TransferRoute,this);fnContextMenu("popItem")</xsl:attribute>
  <xsl:attribute name='gjsItem'><xsl:value-of select='route/@function' />|<xsl:value-of select='route/@from' />|<xsl:value-of select='route/@to' /></xsl:attribute>
  <xsl:attribute name='gjsReferenceHeadingId'><xsl:value-of select='$divReferenceHeadingId' /></xsl:attribute>
  <xsl:attribute name='id'><xsl:value-of select='$rowId' />main</xsl:attribute>
	<xsl:if test='/ServerLink/allowedMethods/method[@name="TransferRoute.fnOpen"]'>
		<xsl:attribute name='ondblclick'>TransferRoute.Item.fnOpen()</xsl:attribute>
	</xsl:if>
	<xsl:if test='route/@genByKey!=""'>
		<xsl:attribute name='class'>disabledRow</xsl:attribute>
	</xsl:if>
	<xsl:if test='route/@disabled="1"'>
		<xsl:attribute name='style'>text-decoration: line-through;</xsl:attribute>
	</xsl:if>
</xsl:template>


<xsl:template match='/ServerLink/Rows/Folder/route'>
  <xsl:param name='rowId'/>

  <xsl:variable name='from' select='@from'/>
  <xsl:variable name='to' select='@to'/>
	<xsl:variable name='elementMain'>
		fnElement("<xsl:value-of select='$rowId'/>main")
	</xsl:variable>

  <!-- Icon for record -->
  <td class='noHighlight' width='25px'>
    <img
     width='25px'
     height='16px'>
    <xsl:choose>
      <xsl:when test='@isTemplate="1"'>
        <xsl:attribute name='src'>vcm_template_l.gif</xsl:attribute>
      </xsl:when>
      <xsl:when test='@genByKey!=""'>
        <xsl:attribute name='src'>vcm_derived_l.gif</xsl:attribute>
      </xsl:when>
      <xsl:otherwise>
        <xsl:attribute name='src'>vcm_record_l.gif</xsl:attribute>
      </xsl:otherwise>
    </xsl:choose>
    </img>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:value-of select='@function' />
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap' title='{/ServerLink/locations/location[@location=$from]/@description}'>
      <xsl:value-of select='$from' />
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap' title='{/ServerLink/locations/location[@location=$to]/@description}'>
      <xsl:value-of select='$to' />
    </div>
  </td>

  <td class='treeCell'>
    <xsl:if test='@disabled="1"'>
      <xsl:attribute name='style'>text-decoration: line-through;</xsl:attribute>
    </xsl:if>
    <div nowrap='nowrap'>
      <xsl:value-of select='@accessCodes' />
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:value-of select='@dependentLocations' />
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:value-of select='@newActiveLocations' />
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:value-of select='@masterLocation' />
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:choose>
        <xsl:when test='@transferType="C"'>
          Copy
        </xsl:when>
        <xsl:when test='@transferType="M"'>
          Move
        </xsl:when>
        <xsl:otherwise>
          ??
        </xsl:otherwise>
      </xsl:choose>
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:choose>
        <xsl:when test='@newVersion="1"'>
          Yes
        </xsl:when>
        <xsl:when test='@newVersion="0"'>
          No
        </xsl:when>
        <xsl:otherwise>
          ??
        </xsl:otherwise>
      </xsl:choose>
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:value-of select='@message' />
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:value-of select='@categoryName' />
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:value-of select='@skipCategoryName' />
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:value-of select='@errorCategoryName' />
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:choose>
        <xsl:when test='@sequence="1"'>
          Yes
        </xsl:when>
        <xsl:when test='@sequence="0"'>
          No
        </xsl:when>
        <xsl:otherwise>
          ??
        </xsl:otherwise>
      </xsl:choose>
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:choose>
        <xsl:when test='@disabled="1"'>
          Yes
        </xsl:when>
        <xsl:when test='@disabled="0"'>
          No
        </xsl:when>
        <xsl:otherwise>
          ??
        </xsl:otherwise>
      </xsl:choose>
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:value-of select='@backupFunction' />
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:value-of select='@backupTo' />
    </div>
  </td>
</xsl:template>


<!-- Sub-folder method -->
<xsl:template name='subFolderMethod'>
  <xsl:text>TransferRoute.fnListDerivatives</xsl:text>
</xsl:template>


<!-- Sub-folder arguments -->
<xsl:template name='subFolderArguments'>
  <xsl:param name='rowId'/>
  
	<xsl:variable name='elementMain'>
		fnElement("<xsl:value-of select='$rowId'/>main")
	</xsl:variable>
	
	<xsl:variable name='elementSub'>
		fnElement("<xsl:value-of select='$rowId'/>sub")
	</xsl:variable>

  <xsl:text>"</xsl:text><xsl:value-of select='$rowId'/><xsl:text>main"</xsl:text>
  <xsl:text>+delimiter+getAttr(</xsl:text><xsl:value-of select='$elementMain'/><xsl:text>,"gjsItem")</xsl:text>
  <xsl:text>+delimiter+gjsTree.fnMores(gCurrentCell)</xsl:text>

</xsl:template>


</xsl:stylesheet>
