// document onready
$(function() {
	//
	// Print button
	$('.printme').click(function() {
		window.print();
	});
	//
	// Search functionality
	$('#searchbutton').click(SubmitSearch);

	$("#searchbox").keypress(function(e) {
		if(e.keyCode == 13) {
			SubmitSearch();
			e.preventDefault();
		}
	});
	//
	// Scrolls page to section if one is defined
	setTimeout(function() {
	  if (window.location.hash) {
		window.scrollTo(0, 0);
		slideToEl(window.location.hash);
	  }
	}, 5);
	//
	// Highlights the 'Home' button on the menu bar if user is on the homepage
	currentdoc = getFileName();
	if (currentdoc == 'index.html') {
		$('#nav-home').addClass('active');
	}
	//
	// Remove 'Web Edition' link if we are on the web edition
	if (location.hostname == "www.georgejames.com" || location.hostname == "georgejames.com") $('#nav-webcopy').css('display','none');
	//
	// Check for PHP - if none then remove search functionality
	if (location.protocol == 'file:') {
		$('#searchonwebcopy').css('display','block');
	} else {
		$.ajax({
			url: "php-test.php", 
			success: function(data) {
				if (data == "IT LIVES!") {
					$('#search-input').css('display','block');
				} else {
					$('#searchonwebcopy').css('display','block');
				}
			},
			error: function() {
				$('#searchonwebcopy').css('display','block');
			}
		});
	}
	//
	// Initialise the annotations functionality
	var annotations = Annotation.init();
	// Check to see if the user has chosen to visit the page with annotations pre-enabled (if the URL includes ?gjannotate)
	var gja = unescape(window.location.search.substring(1));
	if (gja == 'gjannotate') {
		annotations.enableAnnotation();
	}
});

function slideToEl(el) {
	window.location.hash = el;
	if ($(el).length > 0) $('html, body').scrollTop($(el).offset().top - 80);
}
function getFileName() {
	var url = document.location.href;
	url = url.substring(0, (url.indexOf("#") == -1) ? url.length : url.indexOf("#"));
	url = url.substring(0, (url.indexOf("?") == -1) ? url.length : url.indexOf("?"));
	url = url.substring(url.lastIndexOf("/") + 1, url.length);
	return url;
}

function SubmitSearch() {
	var searchstring = $('#searchbox').val();
	window.location = "search.php?" + searchstring;
}
