//vc/ gjsBase - Base utility functions
//vc/ Copyright 2010 George James
//vc/ Object:    gjsBase.js

// gjsBase class
gjsBase = {}

  // Public - Add backslashes in front of special characters, yielding a string literal. Useful when preparing an eval() argument
  // Takes its name from the PHP addslashes function which it mimics.
  // Equivalent to Cache's $ZCONVERT(sIn,"O","JS"), and similar to QuoteJS method of %CSP.Page, except that the latter adds leading and trailing single-quote
gjsBase.fnAddSlashes = function(sIn) {
  var sOut;
  // Convert ' to \', " to \", \ to \\
  sOut = sIn.replace(/([\'\"\\])/g,'\\$1');
  // Convert ASCII 0 to \0
  sOut = sOut.replace(/\0/g,'\\0');
  // Convert other special control characters to their \-form
  // Note that \b has a special meaning in a regex, so [\b] is used to find backspace and change it to \b
  sOut = sOut.replace(/[\b]/g,'\\b');
  sOut = sOut.replace(/\t/g,'\\t');
  sOut = sOut.replace(/\n/g,'\\n');
  sOut = sOut.replace(/\v/g,'\\v');
  sOut = sOut.replace(/\f/g,'\\f');
  sOut = sOut.replace(/\r/g,'\\r');
  return sOut
}
