<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>

<!-- This template inserts stuff into the xml file -->

<xsl:stylesheet
    version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xalan="http://xml.apache.org/xalan">
    <xsl:output method='xml' indent='yes' xalan:indent-amount='2'/>
    <xsl:strip-space elements="*"/>
    
    <xsl:param name="statusFile" select="''"/>
    <xsl:param name="status" select="document($statusFile)"/>


    <!-- Identity template - copy everything as is -->
    <xsl:template match="@*|node()">
        <xsl:copy>
            <xsl:apply-templates select="@*|node()"/>
        </xsl:copy>
    </xsl:template>

    <!-- Swallow ;vc; comments within the production element that may have been previously generated -->
    <xsl:template match="/Production/comment()[contains(.,' //Deltanji// ')]"/>

    <!-- Add component status comment before each item -->
    <xsl:template match="/Production/Item">
        <xsl:variable name='itemName'><xsl:value-of select='@Name'/></xsl:variable>
        <xsl:variable name='itemClassName'><xsl:value-of select='@ClassName'/></xsl:variable>
        <xsl:variable name='statusValue' select='$status/status/component[@name=$itemName and @className=$itemClassName]/@status'/>
        <xsl:variable name='objectVersion' select='$status/status/component[@name=$itemName and @className=$itemClassName]/@objectVersion'/>
        <xsl:variable name='component' select='$status/status/component[@name=$itemName and @className=$itemClassName]/@id'/>
        <xsl:variable name='statusExternal'>
            <xsl:choose>
                <xsl:when test='$statusValue="0"'>Registered   DO NOT EDIT </xsl:when>
                <xsl:when test='$statusValue="1"'>Checked-out              </xsl:when>
                <xsl:when test='$statusValue="2"'>Unregistered             </xsl:when>
                <xsl:otherwise/>
            </xsl:choose>
        </xsl:variable>
        <xsl:text>&#10;&#10;  </xsl:text>
        <xsl:comment> //Deltanji// Status: <xsl:value-of select='$statusExternal'/> </xsl:comment>
        <xsl:text>&#10;  </xsl:text>
        <xsl:copy>
            <xsl:apply-templates select="@*"/>
            <xsl:apply-templates select="node()"/>
        </xsl:copy>
    </xsl:template>


</xsl:stylesheet>
