<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>

<!-- This template merges the Item elements from the destination production
     into the Production element in the source xml file -->

<xsl:stylesheet
    version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xalan="http://xml.apache.org/xalan">
    <xsl:output method='xml' indent='yes' xalan:indent-amount='2'/>
    <xsl:strip-space elements="*"/>
    
    <xsl:param name="productionAtDestinationFile" select="''"/>
    <xsl:param name="productionAtDestination" select="document($productionAtDestinationFile)"/>

    <!-- Identity template - copy everything as is -->
    <xsl:template match="@*|node()">
        <xsl:copy>
            <xsl:apply-templates select="@*|node()"/>
        </xsl:copy>
    </xsl:template>

    <!-- Swallow any existing Item elements in source file (there shouldn't be any) -->
    <xsl:template match="/Production/Item">
    </xsl:template>

    <!-- Insert items after the last child within the Production element -->
    <xsl:template match="/Production/*[not(self::Item)][last()]">
        <xsl:copy>
            <xsl:apply-templates select="@*|node()"/>
        </xsl:copy>
        <xsl:apply-templates select='$productionAtDestination/Production/Item' mode='destination' />
    </xsl:template>

    <!-- Identity template - copy everything as is -->
    <xsl:template match="@*|node()" mode='destination'>
        <xsl:copy>
            <xsl:apply-templates select="@*|node()"/>
        </xsl:copy>
    </xsl:template>

</xsl:stylesheet>
