//vc/ Deltanji Front End - Main
//vc/ Copyright 1999,2004 George James
//vc/ Object:    %Serenj70/js.21
//vc/ Component: T.vc700.js


// Note:
// All functions marked Public can be attached to a menu.  This is user configurable.
// Please keep the list of menu functions in ^%Serenjmnu that is attached to this object in sync.
// This list is available as a lookup in Menu Maintenance.

// What belongs where? - **work in progress**
// - Essential methods for operation, that are non-Deltanji specific belong in Main.js
// - Deltanji specific methods belong in vc700.js if they are common, or in the appropriate .js file
// - Methods that are not essential, but not specific to Deltanji (like fnDebug) belong in the Utility class
// - Ultimately only Main.js should be required for other gJax applications (like CWASP)

	// Global variables
	delimiter='\001'

	// Currently selected Location Folder
	g_oSelectedFolder=null

	// Currently selected item (change request, object or component)
	g_oSelectedItem=null

	// Work List array
	arrWorkList=new Array()

	// Drag-n-drop
	g_oDropTimer=null
	g_oLcodeOver=null
	g_oMouseButton=-1
	g_bDndUnderway=false
	g_bDropTargetsDirty=true

	// Connection data
	var user=null
	var gSession=null

	// Current Cell for pending +/- toggles (fnToggle)
	gCurrentCell=null

	// Pop-up Windows
	var winConnect=null;
	var winTransfer=null;
	var winHelp=null;
	var winPage=null;
	var winChref=null;
	var winObj=null;
	var winMerge=null;
	var winPreConnectProperties='left=200,top=200,width=450,height=550,toolbar=no,location=no,directories=no,status=no,resizable=yes,menubar=no';
	var winConnectProperties='left=200,top=200,width=350,height=210,toolbar=no,location=no,directories=no,status=no,resizable=yes,menubar=no';
	var winHelpProperties='left=0,top=0,width=1000,height=700,toolbar=no,location=yes,directories=no,status=yes,resizable=yes,menubar=no,scrollbars=yes';
	var winPageProperties='left=100,top=100,width=700,height=550,toolbar=no,location=no,directories=no,status=yes,resizable=yes,menubar=no';
	var winPrintProperties='left=0,top=0,height=600,width=800,toolbar=no,location=no,directories=no,status=no,resizable=yes,menubar=yes,scrollbars=yes';


	// Panel resize state info
	g_oResize=null;

	// Drag State Stuff
	g_offsetY=0;
	g_offsetX=0;

  // Implement quote() method for String on browsers that don't provide it natively
if (!String.prototype.quote) {
    String.prototype.quote = function () {
        var c, i, l = this.length, o = '"';
        for (i = 0; i < l; i += 1) {
            c = this.charAt(i);
            if (c >= ' ') {
                if (c === '\\' || c === '"') {
                    o += '\\';
                }
                o += c;
            } else {
                switch (c) {
                case '\b':
                    o += '\\b';
                    break;
                case '\f':
                    o += '\\f';
                    break;
                case '\n':
                    o += '\\n';
                    break;
                case '\r':
                    o += '\\r';
                    break;
                case '\t':
                    o += '\\t';
                    break;
                default:
                    c = c.charCodeAt();
                    o += '\\u00' + Math.floor(c / 16).toString(16) +
                        (c % 16).toString(16);
                }
            }
        }
        return o + '"';
    };
}

//Closure that hooks window.open so we can massage 'left=NNN' and 'top=NNN' values of features string to keep the window on the same display
window.open = function (open) {
	return function (url, name, features) {
		var REtop=/top\s*=\s*(\d+)\s*,/g
		var REleft=/left\s*=\s*(\d+)\s*,/g
		var x
		x = REtop.exec(features);
		var top = x ? parseInt(x[1]) : 0;
		features = features.replace(REtop, '')
		x = REleft.exec(features);
		var left = x ? parseInt(x[1]) : 0;
		features = features.replace(REleft, '')
		features = 'left=' + (window.screenX + left) + ',top=' + (window.screenY + top) + ',' + features
		//
		return open.call(window, url, name, features);
	};
}(window.open);

	// Set orefs to this class when you want them to appear disabled on the menu
	// eg Worklist=Disabled;	
Disabled = {}

	// Reports super-class
Report = {}

	// Create classes within this class if you want to enable/disable them programmatically.
	// eg:
	//   On the menu there is a method Worklist.fnClear()
	//   Initially Worklist=Disabled; which means that the menu item will appear as disabled
	//   Declare the function Internal.Worklist.fnClear() {...}
	//   When you want to enable Worklist methods then Worklist=Internal.Worklist;
	//   When you want to disable Worklist methods then Worklist=Disabled;
	//	
Internal = {}

	// Private - Right click menu
	
var cMenu = false;

function fnContextMenu(sMenu) {
	var el;
	if (typeof(sMenu)=='undefined') sMenu='';
	el=fnElement('popmenu.'+sMenu);
  
  // Note the first (i.e. innermost element) context menu we get called for
	if (el && !cMenu) cMenu = el;
}


// Set handler for mouse right-click action
$(function() {
	$(document).on('contextmenu',function(e) {
		if (cMenu) Menubar.fnjQUIMenuPopup(cMenu,e);
		cMenu = false;
		if ((e.target.tagName != 'INPUT') && (e.target.tagName != 'TEXTAREA')) {
			fnEventStop(e);
		}
	});
});


	// -------------------------------------------------------------------------
	// Class state manipulation methods
	// -------------------------------------------------------------------------
Class = {}

	// Clear selected item of selected class
Class.fnClear = function() {
	if (SelectedClass!=Disabled) {
		Class.fnUnselect()
		SelectedClass=Disabled
	}
	//
	// Always reinit the multiselect array
	SelectedClass.selectedCells=new Array()
}


	// Select an item of a class
Class.fnSelect = function(oClass,oCell) {
	Class.fnClear()
	// fnClear removes highlight from old selectedCells[], so reinstate ours
	if (oCell.className!='selected') {
		setAttr(oCell,'gjsSavedClassName',oCell.className)
	$(oCell).addClass('selected');
	}
	SelectedClass=oClass
	SelectedClass.selectedCells=new Array()
	//
	SelectedClass.Current=SelectedClass.Item
	//
	SelectedClass.selectedCell=oCell
	SelectedClass.selectedItem=getAttr(oCell,"gjsItem")
	SelectedClass.selectedCells[0]=oCell.id
}


	// Select an item of a class that support multiselect
Class.fnSelect2 = function(oClass,oCell,event) {
	var i;
	var oStartCell=oCell;
	//
	// If it's a different class then start afresh
	if (SelectedClass!=oClass) {
		fnItemSelect(oCell)
		Class.fnSelect(oClass,oCell)
		return
	}
	//
	SelectedClass.Current=SelectedClass.Item
	//
	if (typeof(SelectedClass.selectedCell)=='object') {
		oStartCell=SelectedClass.selectedCell
	}
	SelectedClass.selectedCell=oCell
	SelectedClass.selectedItem=getAttr(oCell,"gjsItem")
	//
	if (event.shiftKey) {
		Class.fnAddRangeToSelection(oStartCell,oCell)
	}
	if (event.ctrlKey) {
		i=Class.fnSelectionIndex(oCell)
		if (i<0) {
			// Make sure we have a selectedCells array
			if (typeof(SelectedClass.selectedCells)!='object') {
				SelectedClass.selectedCells=new Array()
			}
			// Add it
			$(oCell).addClass('selected')
			SelectedClass.selectedCells[SelectedClass.selectedCells.length]=oCell.id
		}
		else {
			$(oCell).removeClass('selected')
			SelectedClass.selectedCells[i]=null
		}
	}
	// If neither the shift or control keys were down then do nothing here in the on mouse down handler.  It may
	// be the start of a mouse move event, if not then we make a fresh single selection in the mouse up
	// event handler.
}

	// Select everything between two cells (2nd must follow 1st)
Class.fnAddRangeToSelection = function(oCell1,oCell2) {
	var sBodyId1=getAttr(oCell1,"gjsRowId")+'body';
	var sBodyId2=getAttr(oCell2,"gjsRowId")+'body';
	var sId;
	var oBody1=fnElement(sBodyId1);
	var oBody2=fnElement(sBodyId2);
	var oCell;
	var oEndCell;

	if (oBody1.offsetTop>oBody2.offsetTop) {
		oCell=oCell2;
		oEndCell=oCell1;
	}
	else {
		oCell=oCell1;
		oEndCell=oCell2;
	}

	Class.fnAddCellToSelection(oCell);

	while (oCell!=oEndCell) {
		sBodyId1=getAttr(oCell,"gjsRowId")+'body';
		oBody1=fnElement(sBodyId1);
		oBody2=oBody1.nextElementSibling;
		if (oBody2==null) break;
		sBodyId2=oBody2.id;
		sId=sBodyId2.slice(0,-4);
		oCell=fnElement(sId+'main');
		if (oCell==null) break;
		Class.fnAddCellToSelection(oCell);
	}
}


	// Select everything in the table
Class.fnAddAllToSelection = function(oClass,oTable) {
	var i
	var sId
	//
	if (oClass!=SelectedClass) {
		Class.fnClear()
		SelectedClass=oClass
		SelectedClass.selectedCells=new Array()
	}
	//
	for (i=0;i<oTable.tBodies.length;i++) {
		sId=getAttr(oTable.tBodies[i],"gjsRowId")
		if (sId=='') continue
		oCell=fnElement(sId+'main')
		if (oCell==null) break
		
		// Skip if folder, unless it has a gjsOnSpace attribute (which probably makes it selectable)
		if ((fnElement(sId+'hiddenRow')) && !(getAttr(oCell,"gjsOnSpace"))) continue
		//
		Class.fnAddCellToSelection(oCell)
	}
}


	// Add one cell to multi-select
Class.fnAddCellToSelection = function(oCell) {
	//
	if (Class.fnSelectionIndex(oCell)<0) {
		// Make sure we have a selectedCells array
		if (typeof(SelectedClass.selectedCells)!='object') {
			SelectedClass.selectedCells=new Array()
		}
		// Add this cell
		$(oCell).addClass('selected')
		SelectedClass.selectedCells[SelectedClass.selectedCells.length]=oCell.id
	}
}


	// Index of oCell in SelectedClass.selectedCells[], or -1 if not found
Class.fnSelectionIndex = function(oCell) {
	var i=-1;
	if (typeof(SelectedClass.selectedCells)=='object') {
		for (i=SelectedClass.selectedCells.length-1; i>-1; i--) {
			if (SelectedClass.selectedCells[i]==oCell.id) {
				break;
			}
		}
	}
	return i;
}


Class.fnUnselect = function() {
	//
	var oEl
	if (typeof(SelectedClass.selectedCells)=='object') {
		for (var i=0; i<SelectedClass.selectedCells.length; i++) {
			if (SelectedClass.selectedCells[i]!=null) {
				oEl=fnElement(SelectedClass.selectedCells[i])
				if (oEl!=null) {
					$(oEl).removeClass('selected')
				}
			}
		}
		delete SelectedClass.selectedCells
	}
	delete SelectedClass.selectedCell
	SelectedClass.Current=Disabled
}


Class.fnSelectionCount = function() {
	var iCount=0;
	if (typeof(SelectedClass.selectedCells)=='object') {
		for (var i=0; i<SelectedClass.selectedCells.length; i++) {
			if (SelectedClass.selectedCells[i]!=null) {
				iCount++
			}
		}
	}
	return iCount
}

Class.fnSelectionAsList = function(sDelim) {
	var oEl;
	var iCount=0;
	var sItems='';
	if (typeof(sDelim)!='string') {
		sDelim='\002';
	}
	if (typeof(SelectedClass.selectedCells)=='object') {
		for (var i=0; i<SelectedClass.selectedCells.length; i++) {
			if (SelectedClass.selectedCells[i]!=null) {
				oEl=fnElement(SelectedClass.selectedCells[i]);
				if (oEl!=null) {
					iCount++;
					sItems=sItems+sDelim+getAttr(oEl,"gjsItem");
				}
			}
		}
	}
	return iCount+sItems;
}

	// Return true if all selected items have the same gjsParentId
Class.fnSelectionIsContiguous = function() {
	var oEl;
	var sParentId='';
	// Find first gjsParentId
	for (var i=0; i<SelectedClass.selectedCells.length; i++) {
		if (SelectedClass.selectedCells[i]!=null) {
			oEl=fnElement(SelectedClass.selectedCells[i]);
			if (oEl!=null) {
				sParentId=getAttr(oEl,"gjsParentId");
				if (sParentId!='') break;
			}
		}
	}
	if (sParentId=='') return false;
  
	// Check they all match
	for (var i=0; i<SelectedClass.selectedCells.length; i++) {
		if (SelectedClass.selectedCells[i]!=null) {
			oEl=fnElement(SelectedClass.selectedCells[i]);
			if (oEl!=null) {
				if (getAttr(oEl,"gjsParentId")!=sParentId) return false;
			}
		}
	}
	return true;
}

  // Session methods
Session = {}

Session.fnPurge = function() {
	var yn;
	yn=confirm("Are you sure to want to purge session information?  \nThis will purge all historical sessions that are more than 10 days old. ")
	if (yn) parent.serverLink.fnDo('Session.fnPurgeResult','Session.fnPurge','') ;
}


Session.fnPurgeResult = function() {
	alert("Sessions purged.")
}


Session.fnDebugOn = function() {
	ServerLink.fnDo('Session.fnDebugOnResult','Session.fnDebugOn','');
}

Session.fnDebugOnResult = function() {
	defaultStatus=defaultStatus+' - Serenji debugger enabled'
	if (document.getElementById("cmdDebugOn")) document.getElementById("cmdDebugOn").disabled=true
	if (document.getElementById("cmdDebugOff")) document.getElementById("cmdDebugOff").disabled=false
}


Session.fnDebugOff = function() {
	ServerLink.fnDo('Session.fnDebugOffResult','Session.fnDebugOff','');
}

Session.fnDebugOffResult = function() {
	defaultStatus=defaultStatus.split(' - Serenji')[0]
	if (document.getElementById("cmdDebugOn")) document.getElementById("cmdDebugOn").disabled=false
	if (document.getElementById("cmdDebugOff")) document.getElementById("cmdDebugOff").disabled=true
}


	// Public - Record current selection in ^%Serenjsel, then invoke client-side sFunction
	// as sFunction(iVCselKey) or sFunction(iVCselKey,...)
function fnInvokeOnSelection(sFunction, sArgs) {
	var sSelType;
	
	// This needs to work in pure gJax context when no ChangeRequest or Component functions exist
	// (an Object function always exists in JavaScript; Deltanji overloads it with its own)
	if (SelectedClass==Object) {
		sSelType='O';
	}
	else if ((typeof(ChangeRequest)!='undefined') && (SelectedClass==ChangeRequest)) {
		sSelType='CHREF';
	}
	else if ((typeof(Component)!='undefined') && (SelectedClass==Component)) {
		sSelType='COMPONENT';
	}
	else {
		sSelType='unspecified';
	}
	parent.serverLink.fnDo('fnInvokeOnSelectionResult','Selection.fnSave',sSelType+delimiter+Class.fnSelectionAsList()+delimiter+sFunction+delimiter+sArgs);
}

	// Public- Result of above (may also be used by specialized variants of above)
function fnInvokeOnSelectionResult(result) {
	//
	var arrResult
	var arrData
	var sFunction
	var iKey
	var sOtherArgs
	//
	arrResult=result.split('\001')
	arrData=arrResult[0].split('\002')
	sFunction=arrData[1]
	iKey=arrData[2]
	sOtherArgs=arrData[3]
	if (sOtherArgs!='')
		sOtherArgs=','+sOtherArgs
	eval(sFunction+'('+iKey+sOtherArgs+')')
}


	// Deprecated - Use fnElement - This function will return an object handle given the name of the object
function fnGetObj(str) {
	return fnElement(str);
}


	// Private - Get Element By Id
function fnElement(sElement) {
	return document.getElementById(sElement);
}

	// Private - Open/Close a folder (fired by clicking on its +/- button)
function fnToggle(thisCell) {
  //
	var oPlus,oHiddenRow,sNameProp
  //
  //
  if (getAttr(thisCell,"gjsState") == "closed") {
	fnToggleExpand(thisCell)
  } else {
  	oPlus=fnGetObj(getAttr(thisCell,"gjsPlusId"))
    oHiddenRow=fnGetObj(getAttr(thisCell,"gjsHiddenRowId"))
    sNameProp=Utility.fnGetNameProp(getAttr(oPlus,"src"))
    if (sNameProp=="vcm_minus_tbr.gif") setAttr(oPlus,"src","vcm_plus_tbr.gif")
    if (sNameProp=="vcm_minus_tr.gif") setAttr(oPlus,"src","vcm_plus_tr.gif")
    if (sNameProp=="vcm_working_tbr.gif") setAttr(oPlus,"src","vcm_plus_tbr.gif")
    if (sNameProp=="vcm_working_tr.gif") setAttr(oPlus,"src","vcm_plus_tr.gif")
		setAttr(thisCell,"gjsState","closed")
    $(oHiddenRow).removeClass().addClass("tocItemHide")
  }
}

  // Public - Expand a folder even if already expanded; reload contents
  // 
function fnToggleExpand(thisCell) {
	var oPlus,sNameProp
  //
	oPlus=fnGetObj(getAttr(thisCell,"gjsPlusId"))
  sNameProp=Utility.fnGetNameProp(getAttr(oPlus,"src"))
  //
  if (sNameProp=="vcm_plus_tbr.gif") setAttr(oPlus,"src","vcm_working_tbr.gif")
  if (sNameProp=="vcm_plus_tr.gif") setAttr(oPlus,"src","vcm_working_tr.gif")
	setAttr(thisCell,"gjsState","open")
  //
	gCurrentCell=thisCell
  if (getAttr(thisCell,"gjsServerLink")=="no") eval(getAttr(thisCell,"gjsRowGenerator"))
  else parent.serverLink.fnDo('fnToggleExpandResult',getAttr(thisCell,"gjsRowGenerator"),eval(getAttr(thisCell,"gjsArguments")))
}


function fnToggleExpandResult(result) {
  //
	var oHiddenRow,oTargetCell,oPlus,sNameProp,oDivMainBody
	//
  oHiddenRow=fnGetObj(getAttr(gCurrentCell,"gjsHiddenRowId"));
  oTargetCell=fnGetObj(getAttr(gCurrentCell,"gjsTargetCellId"));
  oPlus=fnGetObj(getAttr(gCurrentCell,"gjsPlusId"));
  sNameProp=Utility.fnGetNameProp(getAttr(oPlus,"src"))
  //
	// If ServerLink.xsl is used then result will be an object reference
	if (typeof(result)=='object') {
		oDivMainBody=result.getElementById('divMainBody')
		if (oDivMainBody) {
      //
      // If there's a folder caption heading then update it
      ServerLink.fnUpdate(result,'divFolderHeadingCaption')
      //
      // Copy divMainBody from result to document
			$(oTargetCell).html($(oDivMainBody).html());
			//
			// Copy any column headings to the correct place
			ServerLink.fnUpdate(result,'divMainHead', Main.fnIdOfHeadingDiv(oTargetCell))
			//
			if (getAttr(oDivMainBody,"gjsLoad")) eval(getAttr(oDivMainBody,"gjsLoad"))
      //
      // Reveal the hidden row
			$(oHiddenRow).removeClass().addClass("tocItemShow");
		}
	}
	else {
		if (result!='') {
			$(oTargetCell).html(result);
			$(oHiddenRow).removeClass().addClass("tocItemShow");
		}
    //
    // If no results returned then replace the +/- icon with a regular T or L icon
		else {
      if (sNameProp=="vcm_minus_tbr.gif") setAttr(oPlus,"src","vcm_t.gif")
      if (sNameProp=="vcm_minus_tr.gif") setAttr(oPlus,"src","vcm_l.gif")
      sNameProp=""
		}
	}
  if (sNameProp=="vcm_working_tbr.gif") setAttr(oPlus,"src","vcm_minus_tbr.gif")
  if (sNameProp=="vcm_working_tr.gif") setAttr(oPlus,"src","vcm_minus_tr.gif")
	gCurrentCell=null
}


	// Keyboard event handler for tree control row
function fnToggleKey(clickId,event) {
	var thisCell=fnGetObj(clickId);
	var bOK=false;
	if (getAttr(thisCell,"gjsState")=='closed') {
		// <CursorRight>
		if (event.keyCode==39) bOK=true;
		// + on numpad
		if (event.keyCode==107) bOK=true;
		// + on main
		if (event.keyCode==187) bOK=true;
	}

	if (getAttr(thisCell,"gjsState")=='open') {
		// <CursorLeft>
		if (event.keyCode==37) bOK=true;
		// - on numpad
		if (event.keyCode==109) bOK=true;
		// - on main
		if (event.keyCode==189) bOK=true;

	}

	if (bOK) {
		fnToggle(thisCell);
		fnEventStop(event);
	}		
}


	// Unselect any previously selected location
function fnFolderClear() {
	if (g_oSelectedFolder) {
		var oFolderIcon=fnGetObj(getAttr(g_oSelectedFolder,"gjsFolderId"));
		if (oFolderIcon) setAttr(oFolderIcon,"src",(getAttr(oFolderIcon,"gjsImage")!=null) ? getAttr(oFolderIcon,"gjsImage") : 'vcm_folder.gif');
		$(g_oSelectedFolder).removeClass();
		g_oSelectedFolder=null;
		Class.fnClear();
		fnItemClear();
		$(divFolderHeadingCaption).html('&nbsp;')
	}
}


	// Select a folder, with event passed so Firefox can access it in Select.fnFolderSelect
function fnFolderSelect(oCell, event) {
	var oFolderIcon;
	//
	// Unselect previous
	fnFolderClear();
	//
	// Record selected folder for later use
	g_oSelectedFolder=oCell;
	$(g_oSelectedFolder).addClass('selected');
	//
	// Open and highlight selected folder icon
	oFolderIcon=fnGetObj(getAttr(g_oSelectedFolder,"gjsFolderId"));
	if (oFolderIcon) setAttr(oFolderIcon,"src",(getAttr(oFolderIcon,"gjsImageOpen")!=null) ? getAttr(oFolderIcon,"gjsImageOpen") : (getAttr(oFolderIcon,"gjsImage")!=null) ? getAttr(oFolderIcon,"gjsImage") : 'vcm_folder_open.gif');
	//
	// Update the selection toolbar
	Select.fnFolderSelect(event)
}


function fnSelectedItemHide() {
	$(g_oSelectedItem.parentElement.parentElement).removeClass().addClass("tocItemHide");
	g_oSelectedItem.blur();
	g_oSelectedItem=null;
}


	//Populate divMainBody with location data
function fnGetLcode(oThisCell) {
	var oFolder;
	//
	divMainHead.innerHTML=''
	//
	fnFolderSelect(oThisCell);
	//
	// Get location details for right-hand panel
	parent.serverLink.fnDo('fnGetLcodeResult','Location.fnSummary',getAttr(g_oSelectedFolder,"gjsItem")) ;
}


function fnGetLcodeResult(result) {
  document.getElementById("divMainBody").innerHTML=result;
}


	// Private - Display message in info panel while we wait
function fnMessageSelecting() {
	html = '<div id=divInfo>';
	html += '<img src="vcm_info.gif">';
	html += '<p>Fetching selection from server...</p>';
	html += '</div>';
	document.getElementById("divMainBody").innerHTML=html;
}


	//----------------------------------------------------------------------
	// Drag'n'Drop methods
	//----------------------------------------------------------------------

function fnItemClear() {
	if (!g_oSelectedItem) return;
	$(g_oSelectedItem).removeClass('selected');
	g_oSelectedItem=null;
}


	// Private - Select Item (get focus)
function fnItemSelect(oCell) {
	if (typeof(SelectedClass.selectedCells)=='undefined') {
		fnItemClear();
	}
	//
	g_oSelectedItem = oCell;
	//
	// Highlight the selected cell
	$(g_oSelectedItem).addClass('selected');
	//
	// Give the item focus (so that it has a dotted line around it)
	// and so it gets subsequent key-events
	g_oSelectedItem.focus();
	//
}

	// Attach to onkeydown of table generated by gjs:tree if you want Ctrl+A to select all
	// If tree has selectable folders as well as leaves, and you want Ctrl+A to include those folders,
	// set gjsOnSpace='fnItemSpace(Object,event.target)' on the folder's main element
	// so Class.fnAddAllToSelection doesn't skip it.
function fnTreeTableKeyDown(oClass,oTable,event) {
	if (event.ctrlKey && (event.keyCode==65)) {
		Class.fnAddAllToSelection(oClass,oTable);
		return fnEventStop(event);
	}
}


	// Pseudo event handler for space-key
	// Emulates the click event for items that have MouseDown and MouseUp event handlers
	// rather than an onclick event handler.
function fnItemSpace(oClass,oMain,event) {
	fnItemMouseDown(oClass,oMain,event)
	fnItemMouseUp(oClass,oMain,event)
}


// Mouse down event handler
function fnItemMouseDown(oClass,oMain,event) {
	// Note which button
	if (event) g_oMouseButton=event.button
	//
	// No shift or control key, normal selection
	if ((!event.shiftKey) && (!event.ctrlKey)) {
		if (Class.fnSelectionIndex(oMain)==-1) Class.fnSelect(oClass,oMain)
	}
	//
	fnItemSelect(oMain)
	Class.fnSelect2(oClass,oMain,event)
	//
	// Synchronise column headings to match this particular item
	Main.fnSetMainHead(getAttr(oMain,"gjsReferenceHeadingId"))
	//
	fnEventStop(event)
}


	// onmouseup on multi-select draggable item
	// If the ctrl and shift keys were not down then at this point (and the item was already selected)
	// then behaves like a regular single select and forget any any previous multi-select.  We can't do this on
	// mousedown as the user may be initiating a drag operation, so we wait until the onmouseup event.
	// Test case:  select three items, then select just one of those items (the other two should get deselected)
function fnItemMouseUp(oClass,oCell,event) {
	g_oMouseButton=-1
	//
	if ((event.shiftKey) || (event.ctrlKey)) return
	//
	// Right-click context menu being invoked, do not alter selection 
	if (event.button==2) return
	//
	fnItemSelect(oCell)
	Class.fnSelect(oClass,oCell)
}


	//onmousemove on multi-select draggable item
function fnItemMouseMove(oClass,oCell,event) {
	//
	if (!g_bDndUnderway && (g_oMouseButton==0) && (Class.fnSelectionIndex(oCell)>=0)) {
		fnItemDrag(oCell,event);
		  fnEventStop(event);
	}
  //
  // Our note of the most recent mousedown button gets reset here because if a drag is released when off the window
  // we never see a mouseup in which to reset it
  g_oMouseButton=-1
}


	// Private - Drag Item (fired by onmousedown event)
function fnItemDrag(oCell,event) {
	var iCount;
	//
	fnItemSelect(oCell);
	iCount=Class.fnSelectionCount();
	//
	// Are there any drop targets?
	if (document.getElementsByName('dndLcode').length==0) return;
	if (iCount>1) {
		divDragIcon.innerHTML='<b>&nbsp;'+iCount + '&nbsp;items&nbsp;</b>';
		//
		// Place multi-select drag-div close to the cursor (it may be longer or shorter than the cell text)
		g_offsetX=divDragIcon.offsetWidth*0.75;
		g_offsetY=divDragIcon.offsetHeight*0.5;
	}
	else {
		divDragIcon.innerHTML=g_oSelectedItem.innerHTML;
		//
		// Remember where in the cell the user clicked.  This is used to
		// position the drag-icon relative to the cursor.
		// Can't use offsetX and offsetY as Firefox doesn't supply these.
		g_offsetX=event.clientX - event.target.getBoundingClientRect().left;
		g_offsetY=event.clientY - event.target.getBoundingClientRect().top;
		//divDragIcon.style.removeAttribute('color');
		divDragIcon.style.backgroundColor = 'buttonface';
		divDragIcon.style.color = 'buttontext';
	}
	//
	// Modify cell position to account for the relative position of the
	// divDragIcon (which cannot be on the top of the page because of
	// event conflicts with the drop event on Lcode).
	op=divDragIcon.offsetParent;
	while (op) {
		g_offsetX += op.offsetLeft;
		g_offsetY += op.offsetTop;
		op=op.offsetParent;
	}	
	//
	// Position the drag-icon at the click pos
	divDragIcon.style.left=event.clientX - g_offsetX + 'px';
	divDragIcon.style.top=event.clientY - g_offsetY + 'px';
	//
	//Make DragIcon visible
	divDragIcon.style.cursor='default';
	divDragIcon.style.visibility='visible';
	g_bDndUnderway=true;
	//
	// Set the dirty flag to force the drop target positions
	// to be updated.
	g_bDropTargetsDirty=true;
}


	// Private - Drag Icon
	// Invoked by onmousemove event on body
function fnDragIcon(event) {
	var lcode;
	//
	if (g_oResize) {
		Main.fnResizeMouseMove();
		return;
	}
	//
	if (!g_bDndUnderway) return;
	//
	// maybe need to add +document.body.scrollTop, scrollLeft for scrolling document?
	divDragIcon.style.left = event.clientX - g_offsetX + 'px';
	divDragIcon.style.top = event.clientY - g_offsetY + 'px';
	//
	// Start drop target highlighter
	if (g_oDropTimer) {
		clearTimeout(g_oDropTimer);
	}
	g_oDropTimer = setTimeout('fnDropTarget()',50);
	return;
}


	// Private - Check whether the drag icon is over a drop target
	// Fired 50 milliseconds after the user stops moving the drag icon
function fnDropTarget() {
	//
	var lcodesx,lcode;
	//
	// Update absolute position info on divDragIcon
	fnAbsoluteClippedRect(divDragIcon);
	//
	lcodesx=document.getElementById('dndLcode');
	//
	// Is divDragIcon over the folder top scrolling region?
	if (fnObjectIntersect(divDragIcon,divFolderTop)) {
		divFolder.scrollTop -= 32;
		g_bDropTargetsDirty=true;
		g_oDropTimer = setTimeout('fnDropTarget()',250);
		return;
	}
	//
	// Is divDragIcon over the bottom scrolling region?
	if (fnObjectIntersect(divDragIcon,divFolderBottom)) {
		divFolder.scrollTop += 32;
		g_bDropTargetsDirty=true;
		g_oDropTimer = setTimeout('fnDropTarget()',250);
		return;
	}
	//
	// If anything has moved then update the drop target absolute positions
	if (g_bDropTargetsDirty) fnLcodePositions();
	//
	// What location is the drag icon over?	
	// Get location that drag icon is over (if any) and then select it.
	lcode=fnOverLcode(divDragIcon);
	fnDropTargetSelect(lcode);
	//
	// Set cursor shape based on where 
	// If its not over a location then set cursor
	// and deselect any previously selected location
	if (lcode == null) divDragIcon.style.cursor='not-allowed';
	else divDragIcon.style.cursor='default';
	//
	// Is drag icon over the workList button?
	if (fnWorkListOver(divDragIcon)) {
		$(cmdWorkList).removeClass().addClass('selected');
		divDragIcon.style.cursor='default';
	} 
	else $(cmdWorkList).removeClass().addClass('button');
}


	// Private - Select a drop target
function fnDropTargetSelect(oTarget) {
	//
	// If its the same as before then do nothing
	if (g_oLcodeOver==oTarget) return;
	//
	// De-select any previous location
	if (g_oLcodeOver != null) {
		if ($(g_oLcodeOver).hasClass('selected')) $(g_oLcodeOver).removeClass().addClass('selectable');
		g_oLcodeOver=null;
	}
	//
	// Select current location
	g_oLcodeOver = oTarget;
	if (g_oLcodeOver != null) {
		if ($(g_oLcodeOver).hasClass('selectable')) $(g_oLcodeOver).removeClass().addClass('selected');
	}
}	


	// Private - Tidy up after drop
function fnEndDrag() {
	//
	if (!g_bDndUnderway) return;
	g_bDndUnderway=false;
	divDragIcon.style.cursor='default';
	divDragIcon.style.visibility='hidden';
	//
	// Stop drop target highlighter
	if (g_oDropTimer) {
		clearTimeout(g_oDropTimer);
	}
	//
	// De-select previous location
	if (g_oLcodeOver != null) {
		if ($(g_oLcodeOver).hasClass('selected')) $(g_oLcodeOver).removeClass().addClass('selectable');
		g_oLcodeOver = null;
	}
}


	// Private - Drop Icon
	// Invoked by onmouseup event on divDragIcon
function fnDropIcon() {
	var lcode;
	fnEndDrag();
	//
	// Was it dropped on anything?
	lcode=fnOverLcode(divDragIcon);
	//
	// Was it dropped on the workList?
	if (lcode == null) {
		if (fnWorkListOver(divDragIcon)) {
			$(cmdWorkList).removeClass().addClass('button');
			fnWorkListCopy();
		}
		return ;
	}
	//
	// Dropped it on a location, do the business
	SelectedClass.Current.fnTransfer('',getAttr(g_oSelectedFolder,"gjsItem"),getAttr(lcode,"gjsLcode"));
}


	// Private - Is the divDragIcon over a location
	// If it is then return the object which the drag icon is over
function fnOverLcode(divDragIcon) {
	var overLcode;
	var i;
	//
	overLcode=null;
	//
	// If the drop target positions are not up-to-date then return
	// nothing.  This can happen, for example, if the user did not move the
	// mouse, or if the position update is not yet complete.
	if (g_bDropTargetsDirty) return null;
	//
	lcodesx=document.getElementsByName('dndLcode');
	for (i=0; i<lcodesx.length; i++) {		
		if (fnObjectIntersectCentreLine(divDragIcon,lcodesx[i])) {
			overLcode=lcodesx[i];
			break;
		}
	}
	return overLcode;
}


	// Private - Calculate absolute positions of all locations
	// Clear the dirty flag to indicate that all positions are up to date
function fnLcodePositions() {
  //
	var i
	lcodesx=document.getElementsByName('dndLcode');
	//
	g_bDropTargetsDirty=false;
	//
	for (i=0; i<lcodesx.length; i++) {
		fnAbsoluteClippedRect(lcodesx[i]);
	}
}
	// Private - Determine absolute clipped rectangle of element el
	// returns dimensions in new properties of el:
	// el.gjClippedTop
	// el.gjClippedLeft
	// el.gjClippedBottom
	// el.gjClippedRight
function fnAbsoluteClippedRect(el) {
  var tel=el;
  var tr=el.getBoundingClientRect();
  var pel;
  var ptr;
	//
  el.gjClippedTop = tr.top;
  el.gjClippedLeft = tr.left;
  el.gjClippedBottom = tr.bottom;
  el.gjClippedRight = tr.right;
  do {
    pel = tel.parentNode;
    ptr = pel.getBoundingClientRect();
    if (ptr.top > el.gjClippedTop) el.gjClippedTop = ptr.top;
    if (ptr.left > el.gjClippedLeft) el.gjClippedLeft = ptr.left;
    if (ptr.bottom < el.gjClippedBottom) el.gjClippedBottom = ptr.bottom;
    if (ptr.right < el.gjClippedRight) el.gjClippedRight = ptr.right;
    if ((el.gjClippedRight < el.gjClippedLeft) || (el.gjClippedBottom < el.gjClippedTop)) break;
    tel = pel;
  } while (tel != document.body);
}


	// Private - Determine Absolute Position of Object o
	// returns position in new properties of o:
	// o.absoluteTop
	// o.absoluteLeft
function fnAbsolutePosition(o) {
	var absoluteTop;
	var absoluteLeft;
	var oParent;
	//
	absoluteTop=0;
	absoluteLeft=0;
	oParent=o;
	while (oParent != null) {
		absoluteTop += oParent.offsetTop;
		absoluteLeft += oParent.offsetLeft;
		if (oParent.scrollTop !== (void 'gaga')) absoluteTop -= oParent.scrollTop;
		if (oParent.scrollLeft !== (void 'gaga')) absoluteLeft -= oParent.scrollLeft;
		oParent=oParent.offsetParent;
	}
	o.absoluteTop=absoluteTop;
	o.absoluteLeft=absoluteLeft;
}


	// Private - keydown handler for whole page
function fnKeyDown(event) {
  //
	// Don't interfere with input fields (e.g. select field)
	if ((event.target.tagName=='INPUT') || (event.target.tagName=='TEXTAREA')) 
		return;
	//
	// Special handling of delete key for components, objects in change requests, or change requests in change requests
	if (event.which==46) {
		if (g_oSelectedItem) {
			if (getAttr(g_oSelectedItem,"gjsItemType")=='OBJECT') {
				Object.Current.fnOnKeyDel(); 
				return fnEventStop(event);
			}
			if (getAttr(g_oSelectedItem,"gjsItemType")=='CHREF') {
				ChangeRequest.Current.fnOnKeyDel(); 
				return fnEventStop(event);
			}
			if (getAttr(g_oSelectedItem,"gjsItemType")=='COMPONENT') {
				Component.Current.fnUnregisterAndDelete(event.shiftKey)
				return fnEventStop(event);
			}
		}
		if (SelectedClass) {
			if (typeof(SelectedClass.Current.fnDelete)=='function') {
				SelectedClass.Current.fnDelete();
				return fnEventStop(event);
			}
		}
	}
	//
	// ctrl C for components
	if ((event.which==67)&&(event.ctrlKey)) {
  		fnWorkListCopy();
		return fnEventStop(event);
	}
	//
	// ctrl N for File/New
	if ((event.ctrlKey)&&(event.which==78)) {
		//if (typeof(console)!='undefined') console.log('New');
		//if (typeof(console)!='undefined') console.log(typeof(SelectedClass.fnNew));
		if (typeof(SelectedClass.fnNew)=='function') SelectedClass.fnNew()
		return fnEventStop(event);
	}
	//
	// ctrl O for File/Open
	if ((event.which==79)&&(event.ctrlKey)) {
		//if (typeof(console)!='undefined') console.log('Open');
		//if (typeof(console)!='undefined') console.log(typeof(SelectedClass.Current.fnOpen));
		if (typeof(SelectedClass.Current.fnOpen)=='function') SelectedClass.Current.fnOpen()
		return fnEventStop(event);
	}
 	//
	// ctrl T for Toggle Audit Trail Action
	if ((event.which==84)&&(event.ctrlKey)) {
		if (typeof(SelectedClass.Current.fnActionToggle)=='function') SelectedClass.Current.fnActionToggle()
		return fnEventStop(event);
	}
	//
	// ctrl V for button
	if ((event.which==86)&&(event.ctrlKey)) {
		fnWorkListPaste()
		return fnEventStop(event)
	}
	//
	// Space key
	// gjsOnSpace can be used to override onclick event handing for the space key
	if (event.which==32) {
		if (typeof(getAttr(event.target,"gjsOnSpace"))=='string') eval(getAttr(event.target,"gjsOnSpace"))
		else document.activeElement.click();
		return fnEventStop(event);
	}
	//
	// Alt+1 - Toggle folder window
	if ((event.altKey)&&(event.which==49)) {
		Main.fnFolderShowHide();
		return fnEventStop(event);
	}
	//
	// Alt+2 - Toggle audit window
	if ((event.altKey)&&(event.which==50)) {
		Main.fnAuditShowHide();
		return fnEventStop(event);
	}
	//
	// Esc - relase a drag
	if (event.which==27) {
		fnEndDrag();
		return fnEventStop(event);
	}
	//
	// Ctrl+F5 - Refresh selected item
	if ((event.ctrlKey)&&(event.which==116)) { 
		fnRefreshSelected()
	  return fnEventStop(event)
	}
	//
	// Capture some function keys
	if (event.which==112) { VCm.fnHelp(); return fnEventStop(event); } // F1 - Help
	if (event.which==114) { Utility.fnDebug(); return fnEventStop(event); } // F3 - Search
	if (event.which==116) { fnRefresh(); return fnEventStop(event); } // F5 - Reload
	if (event.which==117) { fnMainSetFocus(); return fnEventStop(event); } // F6 - Toggle frames
	if (event.which==122) { return fnEventStop(event); } // F11 - Full screen
	if (event.which==8) { return fnEventStop(event); } // BackSpace - Browser back
}


  // Bulletproof method for stopping events from bubbling
function fnEventStop(e) {
	var evt = e ? e:window.event;
	evt.keyCode=0; // Required to stop F5 key
	evt.returnValue=false;
	evt.cancelBubble=true;
	if (evt.preventDefault) evt.preventDefault();
	if (evt.stopPropagation) evt.stopPropagation();
	evt.returnValue = false;
	return false;
}


	// Keyboard handler for Folder panel
function fnFolderKeyDown(event) {
	if (event.keyCode==117) { fnMainSetFocus(); return fnEventStop(event); } // F6 - Toggle frames	
}


	// Keyboard handler for Main panel
function fnMainKeyDown(event) {
	if (event.keyCode==117) { fnFolderSetFocus(); return fnEventStop(event); } // F6 - Toggle frames	
}


	// When the user presses Enter then click the cmdOpen button
	// This is done to capture this keystroke which otherwise gets swallowed by
	// the lstSelect scombobox control.
function fnKeyPress(event) {
	if ((event.keyCode==13)&&(typeof(cmdOK)!="undefined")&&(cmdOK.disabled==false)) {
		// Must focus to button first so that onchange event fires on former control
		cmdOK.focus();
    // Defer the click long enough to allow the scombobox blur handling to complete on its 200ms timer
		setTimeout(function(){cmdOK.click();}, 250);
		return false;
	}
}


	// Select toolbar methods
Select = {}
        
	// Last selected Location Folder for detection of selection list change
	Select.oLastFolder=null;

	// Private - Select components
	// This is fired by the onclick event for the Select button on the Select toolbar.
Select.fnSelect = function(select) {
	//
	// Determine what to display based on what is selected in left-hand frame
	if (g_oSelectedFolder) {
  
  	// Workaround - remove a document-level combobox handler before we do something that will
    // destroy and recreate the select combobox
  	$(document).unbind('click.scombobox')
    
  	g_oSelectedFolder.onclick()
  }
	//
	// Nothing selected
	else {
		html = '<div id=divInfo>';
		html += '<img src="vcm_info.gif">';
		html += '<p>You have not selected a location.</p>';
		html += '<p>Please open a location folder in the left-hand window and select a view.</p>';
		html += '</div>';
		//
		document.getElementById("divMainBody").innerHTML=html;
	}
}


	// Record the fact that the user has changed folders
	// If we are looking at a different folder, then unless the ctrl key is pressed
	// then clear the filter and all the buttons so that the last used filters for that
	// location will apply.  Delete the buttons so that the user is not staring at the
	// old settings while waiting for the server...
  // Pass event so Firefox has access to it
	// Clear and disable the select button and dropdown list
Select.fnFolderSelect = function(event) {
  //
  // Is there a select toolbar?
  if (typeof(divToolbarSelect)!='object') return
  //
  // Different folder? Allow for event being null when this is called from the autologout's setTimeout rather than from a user-triggered event
	if ((g_oSelectedFolder!=Select.oLastFolder) && !(event && event.ctrlKey)) {
    $('#lstSelect').scombobox('val','')
    $('#lstSelect').scombobox('disabled',true)
		cmdOK.disabled=true
		divToolbarFilters.innerHTML=''
	}
  //
	Select.oLastFolder=g_oSelectedFolder
}


	// Returns a list of settings for the filter buttons
	// nb the buttons may not exist if the toolbar is not present
Select.fnFilters = function() {
	//
	var filters
	if (typeof(btnEmpty)!='object') return '';
	//
	filters  = getAttr(btnEmpty,"gjsState")
	filters += '\\' + getAttr(btnCheckedOut,"gjsState")
	filters += '\\' + getAttr(btnRegistered,"gjsState")
	filters += '\\' + getAttr(btnError,"gjsState")
	filters += '\\' + getAttr(btnUnregistered,"gjsState")
	filters += '\\' + getAttr(btnSuperseded,"gjsState")
	filters += '\\' + getAttr(btnAllVersions,"gjsState")
	return filters
}


  // Return current filter settings as an html rendered text string
Select.fnFilterText = function() {
  var filterText
  filterText  =' <font color="red" size="1"> Filter: '
  filterText += lstSelect.options[lstSelect.selectedIndex].text
  filterText += '</font>'
  return filterText
}

  // Convert plain lstSelect into jquery-simple-combobox, attach the handlers, and grab focus
Select.fnConvertList = function() {

  // Note whether original control is disabled
  var bDisabled=$('#lstSelect').attr('disabled')
  
  $('#lstSelect').scombobox({
    empty: ($('#lstSelect').attr('value')==''),
    wrap: false,
    loopScrolling: false,
    highlight: false, /* we only match from the start so highlighting is of minimal value */
    expandOnFocus: false,
    expandOnFocusWithValue: false,
    invalidAsValue: true,
    fillOnBlur: false,
    fillOnTab: false,
    filterIgnoreCase: false
  })
  
  // Ensure text size matches its environment, and tweak the padding
  $('#lstSelect .scombobox-display').css('font-size','100%');
  $('#lstSelect .scombobox-list p').css('padding','0px 2px 0px 4px');
  
  // Disable if appropriate
  if (bDisabled=='disabled') {
    $('#lstSelect').scombobox('disabled', true)
  }
  
  // Make the Enter key run the selection
  $('#lstSelect').scombobox('keyup', function(e){
    fnKeyPress(e)
  })

  // Prevent some events from propagating up to the body and being interfered with by the handlers there (see Main.xsl).
  // Otherwise we can't select characters in the filter field using the mouse.
  $('#lstSelect .scombobox-display').on('dragstart selectstart', function(e){
    e.stopPropagation()
  })
  
  $('#lstSelect').scombobox('change', function(){
    cmdOK.value='Select'
  })
  
  // Preselect all the text on entry
  $('#lstSelect').scombobox('focus', function (){
    this.select()
    //
    // Failed attempt to make range selection work in IE
    //setTimeout(function(){$('#lstSelect').children('.scombobox-display').select();}, 1);
  })
  
  if (!$('#lstSelect').scombobox('disabled')) {
    $('#lstSelect').scombobox('focus')
  }
  
  // Disable browser spellcheck
  $('#lstSelect .scombobox-display').attr('spellcheck','false')
}


	//----------------------------------------------------------------------
	// Connect class
	//----------------------------------------------------------------------
Connect = {}


  // Public - Connect As
  // Give user a chance to say who to log in as.
  // First phase, opening a transient window for any interactive CSP authentication.
Connect.fnConnectAs = function() {
	// Disconnect first, passing a true argument for the reconnect parameter, which means the result handler for fnDisconnect brings up the connect dialog
	Connect.fnDisconnect(true);
}


  // Private - ConnectAs2
  // Second phase, called from window opened by Connect.fnConnectAs whose job it is to handle interactive CSP authentication
Connect.fnConnectAs2 = function() {
  parent.serverLink.fnDo('Connect.fnConnect2Result','Connect.fnConnectAs2','')
}


  // Public - Connect
  // Connect automatically if the user is pre-authenticated with the web-server
  // otherwise invoke the manual connection dialog.
  // First phase, opening a transient window for any interactive CSP authentication.
Connect.fnConnect = function() {
	var url;
	//
	// Build url string
	url = parent.serverUrl + '&page=Connect.fnConnect' ;
	//
	// Open Connect/Login window
	winConnect=window.open(url,'Connect',winPreConnectProperties) ;
	if (!winConnect) alert('Do you have pop-ups blocked?')
	winConnect.focus();
}


  // Private - Connect2
  // Second phase, called from window opened by Connect.fnConnect whose job it is to handle interactive CSP authentication
Connect.fnConnect2 = function() {
  parent.serverLink.fnDo('Connect.fnConnect2Result','Connect.fnConnect2','')
}


Connect.fnConnect2Result = function(result) {
  //
  var ok,user
  //
  ok=result.split(delimiter)[0]
  user=result.split(delimiter)[1]
  if (ok==2) alert("vc0006 Access denied: User "+user+" not known")
  if (ok==1) {
		Connect.fnConnected(user)
		if (winConnect) winConnect.close()
	}
  if (ok==0) Connect.fnConnectDialog()
}


  // Private - Invoke the manual connection dialog in a pop-up window
Connect.fnConnectDialog = function() {
	var url;
	//
	// Build url string
	url = parent.serverUrl + '&page=Connect.fnOpen' ;
	url += '&user=' + Main.fnCookie('vcm_user_id') ;
	//
	// Open Connect/Login window
	winConnect=window.open(url,'Connect',winConnectProperties) ;
	if (!winConnect) alert('Do you have pop-ups blocked?')
	winConnect.focus();
}


	// Public - Disconnect from Server
Connect.fnDisconnect = function(reconnect) {
  //
	// Close any open child windows we know about
	if (winTransfer) winTransfer.close();
	if (winHelp) winHelp.close();
	if (winPage) winPage.close();	// Report dialogs
	if (winChref) winChref.close();		
	if (winObj) winObj.close();	
	if (winMerge) winMerge.close();	
	//
	// Reset browser state
	fnFolderClear();
	//
	// Reset the selection toolbar
	Select.fnFolderSelect();
	//
	// Clear/reset divs
	document.getElementById('divFolder').innerHTML='';
	document.getElementById('divSelect').innerHTML='';
	document.getElementById('divMessagesHeading').innerHTMLL='';
	document.getElementById('divMessagesBody').innerHTML='';
	Main.fnWelcome();
	//
	// Close down server side session
	// and then display the mnuDisconnected menu
	//
	// If the reconnect parameter is true, pass the result handler that brings up the connect dialog
	if (reconnect) {
		parent.serverLink.fnDo('Connect.fnDisconnectResult2','Connect.fnDisconnect','');
	} else {
		parent.serverLink.fnDo('Connect.fnDisconnectResult','Connect.fnDisconnect','');
	}
	//
	// Finally forget who the user was
	user=null;
	defaultStatus='Disconnected';
}


Connect.fnDisconnectResult = function(result) {
	document.getElementById("divMenu").innerHTML=result.getElementById('divMenu').innerHTML;
	Menubar.fnTransformDivMenu();
	defaultStatus='Disconnected'
}

Connect.fnDisconnectResult2 = function(result) {
	var url;
	//
	// Build url string
	url = parent.serverUrl + '&page=Connect.fnConnectAs1' ;
	//
	Connect.fnDisconnectResult(result);
	//
	// Open Connect/Login window
	winConnect=window.open(url,'Connect',winPreConnectProperties) ;
	if (!winConnect) alert('Do you have pop-ups blocked?')
	winConnect.focus();
}


	// Public - Once user is connected then we can enable the various bits and bobs
Connect.fnConnected = function(sUser) {
  //
	user=sUser
	defaultStatus='Connected: '+sUser
	//
	// Now we know who the user is we can populate the menus and location list
	fnMenusAndLocations();
}


	//Private - Populate divSelect with user specific menus and then populate locations
function fnMenusAndLocations() {
	parent.serverLink.fnDo('fnDivSelectResult','Main.fnSelect','') ;
}


function fnDivSelectResult(oResult) {
  document.getElementById('divSelect').innerHTML=oResult.getElementById('divSelect').innerHTML;
  if ($('select#lstSelect').length) Select.fnConvertList();
  // Src attributes for button images defined dynamically as a fix for Chrome
  // The Deltanji worklist button also suffered from a broken image until the Select.fnConvertList() call had to be added
  // to make the turn the selector into a combo; this had the bonus side effect of making the image appear.
  $('#cmdHome').attr("src","images/gjaxHome.gif");
  $('#cmdNew').attr("src","images/gjaxNew.gif");
  $('#cmdOpen').attr("src","images/gjaxOpen.gif");
  
  fnDivMenu();
}


	// Private - Populate menu div with user specific menu
function fnDivMenu() {
	parent.serverLink.fnDo('fnDivMenuResult','Main.fnMenu','') ;
}


function fnDivMenuResult(oResult) {
	document.getElementById("divMenu").innerHTML=oResult.getElementById('divMenu').innerHTML;
	Menubar.fnTransformDivMenu();
	fnFolders();
}


	// Private - Populate left hand panel with list of folders
function fnFolders() {
	document.getElementById('divFolder').innerHTML=document.getElementById('divHiddenLoading').innerHTML
	parent.serverLink.fnDo('fnFoldersResult','Folder.fnOpen','mnuFolder'+delimiter+'')
}


function fnFoldersResult(result) {
  document.getElementById("divFolder").innerHTML=result;
	document.getElementById('divMessagesBody').innerHTML='';
  
  // Queue an almost-immediate call to fnAuditLoad so that it works properly in Firefox
  // The 500ms delay seems necessary, else we sometimes lose the event
  setTimeout(fnAuditLoad,500);
}


	// Private - Populate message window with messages that have not been acknowledged
function fnAuditLoad() {
  //
  // Do nothing if no AuditTrail class (e.g. gJax app)
  if (typeof(AuditTrail)!='object') return;
  //
	document.getElementById('divMessagesBody').innerHTML=document.getElementById('divHiddenLoading').innerHTML
	parent.serverLink.fnDo('fnAuditLoadResult','AuditTrail.fnLoad','') 
}


function fnAuditLoadResult(oResult) {
	if (oResult.getElementById('divMainHead')) {
    document.getElementById('divMessagesHeading').innerHTML=oResult.getElementById('divMainHead').innerHTML
		if (getAttr(oResult.getElementById('divMainHead'),"gjsLoad")) eval(getAttr(oResult.getElementById('divMainHead'),"gjsLoad"))
  }
	if (oResult.getElementById('divMainBody')) {
    document.getElementById('divMessagesBody').innerHTML=oResult.getElementById('divMainBody').innerHTML
		if (getAttr(oResult.getElementById('divMainBody'),"gjsLoad")) eval(getAttr(oResult.getElementById('divMainBody'),"gjsLoad"))
  }
	//
	// If there were some messages to display and the message window was closed, then open it
	if (oResult.getElementById('divAutoOpenMessagePanel')) {
		if (Main.messageHeight==0) {
			Main.fnMessageHeightSet(Main.messageHeightLast)
		}
	}
}


	// Private - Populate div object with table containing locations
function fnLocations() {
	parent.serverLink.fnDo('fnLocationsResult','Location.fnFolderList',user) ;
}


function fnLocationsResult(result) {
        document.getElementById("divLocations").innerHTML=result;
}


	// Public - Print main window
function fnPrint() {
	window.open('VCmPrint.htm?preview=0','_blank',winPrintProperties) ;
}


	// Public - Print main window
function fnPrintPreview() {
	window.open('VCmPrint.htm?preview=1','_blank',winPrintProperties) ;
}


	// Public - Print main window
function fnPrintMessages() {
	window.open('vcmPrintMessages.htm?preview=0','_blank',winPrintProperties) ;
}


	// Public - Print main window
function fnPrintPreviewMessages() {
	window.open('vcmPrintMessages.htm?preview=1','_blank',winPrintProperties) ;
}


	// Public - Close browser window
function fnExit() {
	parent.fnClose()
}


	// Unload
	// Trigger: onunload event
	// Disconnects user from Deltanji server
function fnUnload() {	
	//fnDisconnect() ; // Not reliable because it contains a serverLink call
}


window.onunload = fnUnload;


	// Private - Overload fixSize function in vc740.js with call to fnArrangeAll().
	// This causes divs within divOuter to be resized as well.
function fixSize() {
	Main.fnArrangeAll();
}


	//----------------------------------------------------------------------
	// Work List methods
	//----------------------------------------------------------------------


	// Public - Empty the Work List
function fnWorkListClear() {
	//
	arrWorkList=new Array()
	fnWorkListCaption(0)
	//
	// Restore the descriptive tool-tip
	cmdWorkList.title=getAttr(cmdWorkList,"gjsTitle")
	//
	// Disabled the Worklist methods
	Worklist=Disabled
}

	// Public - Return count of worklist items of given type typ (or of any type if typ not passed)
function fnWorkListCount(typ) {
	if (typeof(typ)=='undefined') return arrWorkList.length;
	if (getAttr(cmdWorkList,"gjsType")!=typ) return 0;
	return arrWorkList.length;
}

	// Private - Set the Work List caption based on the number and type of the contents
function fnWorkListCaption(n) {
	if (n==0) {
		workListCaption.textContent='0 items';
	}
	else {
		if (getAttr(cmdWorkList,"gjsType")=='COMPONENT') {
			if (n==1) workListCaption.textContent=' 1 component';
			else workListCaption.textContent=' ' + n + ' components';
		}
		if (getAttr(cmdWorkList,"gjsType")=='OBJECT') {
			if (n==1) workListCaption.textContent=' 1 object';
			else workListCaption.textContent=' ' + n + ' objects';
		}
		if (getAttr(cmdWorkList,"gjsType")=='CHREF') {
			if (n==1) workListCaption.textContent=' 1 change request';
			else workListCaption.textContent=' ' + n + ' change requests';
		}
	}
}


	// Public - Copy the name of the selected item to the Work List
function fnWorkListCopy() {
	var i;
	var oEl;
	// anything selected?
	if (SelectedClass==Component) {
		for (i=0; i<SelectedClass.selectedCells.length; i++) {
			oEl=fnElement(SelectedClass.selectedCells[i]);
			if ((oEl!=null) && (typeof(getAttr(oEl,"gjsCtype"))!='undefined')) fnWorkListAdd(getAttr(oEl,"gjsCtype") + "." + getAttr(oEl,"gjsCname"),'COMPONENT');
		}
	}
	else if (SelectedClass==Object) {
		for (i=0; i<SelectedClass.selectedCells.length; i++) {
			oEl=fnElement(SelectedClass.selectedCells[i]);
			if ((oEl!=null) && (typeof(getAttr(oEl,"gjsItem"))!='undefined')) fnWorkListAdd(getAttr(oEl,"gjsItem"),'OBJECT');
		}
	}
	else if (SelectedClass==ChangeRequest) {
		for (i=0; i<SelectedClass.selectedCells.length; i++) {
			oEl=fnElement(SelectedClass.selectedCells[i]);
			if ((oEl!=null) && (typeof(getAttr(oEl,"gjsItem"))!='undefined')) fnWorkListAdd(getAttr(oEl,"gjsItem"),'CHREF');
		}
	}
}


	// Public - Add item (component or object or CR) to Work List
function fnWorkListAdd(item,typ) {
	//
	// Can only store one type or item
	if ((arrWorkList.length!=0)&&(getAttr(cmdWorkList,"gjsType")!=typ)) {
		setAttr(cmdWorkList,"gjsType",typ)
		fnWorkListClear();
	}
	//
	for (var s in arrWorkList) {
		if (arrWorkList[s]==item) {
			status="Already on work list";
			return;
		}
	}
	//
	// First items to be added
	if (arrWorkList.length==0) {
		// Save the descriptive tool-tip
		setAttr(cmdWorkList,"gjsTitle",getAttr(cmdWorkList,"title"));
		setAttr(cmdWorkList,"title","");
		//
		// Set the type of the list
		setAttr(cmdWorkList,"gjsType",typ);
	}
	//
	// Add item name to tool-tip (first 31 items only)
	if (arrWorkList.length==0) {
		cmdWorkList.title=item
	} else if (arrWorkList.length<31) {
		cmdWorkList.title+="\n"+item
	} else if (arrWorkList.length==31) {
		cmdWorkList.title+="\n..."
	}
	//
	// Store every item and update the button caption
	arrWorkList[arrWorkList.length]=item;
	fnWorkListCaption(arrWorkList.length);
  //
  // Enable Worklist methods
  Worklist=Internal.Worklist
}


	// Public - Paste contents of Work List onto selected target
function fnWorkListPaste() {
	//
	var arguments,oParentFolder;
	//
	// If nothing selected...
	if (arrWorkList.length==0) return;
	//
	if (getAttr(cmdWorkList,"gjsType")=='COMPONENT') {
		//
		if (!g_oSelectedItem) {
			status='An Object must be selected within a Location before pasting Components';
			return;
		}
		//
		status = 'The currently selected item is not an Object within a Location';
		if (getAttr(g_oSelectedItem,"gjsItemType")!='OBJECT') return;
 		oParentFolder = fnGetObj(getAttr(g_oSelectedFolder,"gjsParentId"));
 		if (oParentFolder==null) return;
 		if (getAttr(oParentFolder,"gjsItemType")!='LOCATION') return;
 		status = '';
 		//
 		if (confirm("Are you sure you want to register the following " + ((arrWorkList.length==1)?"component":(arrWorkList.length + " components")) +"\nto Object " + getAttr(g_oSelectedItem,"gjsItem") + " in Location " + getAttr(g_oSelectedFolder,"gjsItem") + " ?\n\n" + getAttr(cmdWorkList,"title") )) {
			//
			arguments  = getAttr(g_oSelectedItem,"gjsItem") 
			arguments += delimiter + getAttr(g_oSelectedFolder,"gjsItem") 
			arguments += delimiter
			for (var s in arrWorkList) {
				arguments += arrWorkList[s] + '\002'
			}
			//
			parent.serverLink.fnDo('fnWorkListPasteResult','Component.fnAddWorkList',arguments);
			fnWorkListClear();
		}
	}
	if (getAttr(cmdWorkList,"gjsType")=='OBJECT') {
		if (!g_oSelectedItem) {
			status='A Change Request must be selected before pasting Objects';
			return;
		}
		if (getAttr(g_oSelectedItem,"gjsItemType")!='CHREF') {
			status='The currently selected item is not a Change Request';
			return;
		}
 		if (confirm("Are you sure you want to add the following " + ((arrWorkList.length==1)?"object":(arrWorkList.length + " objects")) +"\nto " + getAttr(g_oSelectedItem,"gjsPtext") + " " + getAttr(g_oSelectedItem,"gjsItem") + " ?\n\n" + getAttr(cmdWorkList,"title"))) {
			//
			arguments  = getAttr(g_oSelectedItem,"gjsItem") 
			arguments += delimiter
			for (var s in arrWorkList) {
				arguments += arrWorkList[s] + '\\'
			}
			//
			parent.serverLink.fnDo('fnWorkListPasteResult','ChangeRequest.fnAddWorkList',arguments);
			fnWorkListClear();
		}
	}
	if (getAttr(cmdWorkList,"gjsType")=='CHREF') {
		if (!g_oSelectedItem) {
			status='A Change Request must be selected before pasting Change Requests';
			return;
		}
		if (getAttr(g_oSelectedItem,"gjsItemType")!='CHREF') {
			status='The currently selected item is not a Change Request';
			return;
		}
 		if (confirm("Are you sure you want to add the following " + ((arrWorkList.length==1)?"change request":(arrWorkList.length + " change requests")) +"\nto " + getAttr(g_oSelectedItem,"gjsPtext") + " " + getAttr(g_oSelectedItem,"gjsItem") + " ?\n\n" + getAttr(cmdWorkList,"title"))) {
			//
			arguments  = getAttr(g_oSelectedItem,"gjsItem") 
			arguments += delimiter
			for (var s in arrWorkList) {
				arguments += arrWorkList[s] + '\\'
			}
			//
			parent.serverLink.fnDo('fnWorkListPasteResult','ChangeRequest.fnAddWorkListCRs',arguments);
			fnWorkListClear();
		}
	}
}


	// Private - audit messages from adding components to object
function fnWorkListPasteResult(oResult) {
    //
    AuditTrail.fnAppendMessages(oResult)
    fnRefreshSelected()
}


	// Private - Is the divDragIcon over the Work List button
	// If it is then return the object which the drag icon is over
function fnWorkListOver(divDragIcon) {
	//
	// Update absolute position of divDragIcon
	fnAbsoluteClippedRect(divDragIcon);
	fnAbsoluteClippedRect(cmdWorkList);
	//
	return fnObjectIntersect(divDragIcon,cmdWorkList);
}

Internal.Worklist = {
  fnClear: function() {fnWorkListClear();}
}


	//----------------------------------------------------------------------
	// mnuView methods
	//----------------------------------------------------------------------

	// Public - Refresh location window and results window
function fnRefresh() {
	if (g_oSelectedFolder) {
		if ($('select#lstSelect').length) {
			Select.fnSelect($('#lstSelect').scombobox('val'))
		} else {
			Select.fnSelect($('#lstSelect').value)
		}
	}
}	


  // Public - Refresh selected items if there are any and there's a function to do this
function fnRefreshSelected() {
	//
  var arguments,i,oMain
	//
  // If selected class does not support the selected item refresh method then do nothing
	if (typeof(SelectedClass.fnRefresh)!="function") return false
  //
	// If nothing selected then do nothing
	if (typeof(SelectedClass.selectedCells)=="undefined") return false
	//
	// Iterate through each selected item and build a list of refresh arguments:
  arguments=""
	for (i=0; i<SelectedClass.selectedCells.length; i++) {
		if (SelectedClass.selectedCells[i]) {
			oMain=fnElement(SelectedClass.selectedCells[i])
			if (oMain) arguments += SelectedClass.fnRefreshArguments(oMain) + '\003'	
		}
	}
	SelectedClass.fnRefresh(arguments)
	
	return true
}


	// Deprecated - use fnRunWindow
function fnMenuRun(page) {
	fnRunWindow(page);
}


	// Public - Execute page in new window
function fnRunWindow(page,windowProperties) {
	var url;
	//
	// Build url string
	url  = parent.serverUrl ;
	url += '&page=' + escape(page) ;
	//
	// Open transfer window (always in a new window)
	winPage=window.open(url,'_blank',windowProperties) ;
	winPage.focus();
}


	// Public - Run something and direct to divMainHead
function fnRunHeader(page,arguments) {
	//
	parent.serverLink.fnDo('fnRunHeaderResult',page,arguments);
}


function fnRunHeaderResult(result) {
        document.getElementById("divMainHead").innerHTML=result;
}


	// Public - Run something and direct to divMainBody
function fnRunMain(page,arguments) {
	//
	parent.serverLink.fnDo('fnRunMainResult',page,arguments);
}


function fnRunMainResult(result) {
        document.getElementById("divMainBody").innerHTML=result;
}


	// Utility Class
Utility = {}

	// Public - Toggle Debug window
	// If the debug window is closed, open it.
	// Otherwise, close it.
Utility.fnDebug = function() {
	if (parent.framesetMain.cols=='0,1*') parent.framesetMain.cols='250,1*';
	else parent.framesetMain.cols='0,1*';
}


  // Get filename from a URL (should this be here - Utility is supposed to be optional)
  // TODO: Should strip-off ?search and #anchor if present
Utility.fnGetNameProp = function(sSrc) {
  return sSrc.substr(sSrc.lastIndexOf("/")+1)
}

  // Public - Execute anything (possibly should be in Main.js)
Utility.fnExecute = function(javaScript) {
  eval(javaScript)
}


	// Most Recently Used Class
Mru = {}

	// Public - Delete MRU cache for all users
Mru.fnDeleteAll = function() {
	yn=confirm('Are you sure you want to delete the cache of Most Recently Used selection filters for all users?')
	if (yn) parent.serverLink.fnDo('Mru.fnDeleteAllResult','Mru.fnDeleteAll','');
}


Mru.fnDeleteAllResult = function() {
	alert("The most recently used selection filter cache has been deleted for all users")
}


	// Public - Delete MRU for current user
Mru.fnDelete = function() {
	yn=confirm('Are you sure you want to delete your cache of Most Recently Used selection filters?')
	if (yn) parent.serverLink.fnDo('Mru.fnDeleteResult','Mru.fnDelete','');
}


Mru.fnDeleteResult = function() {
	alert("Your most recently used selection filter cache has been deleted")
}


function fnMainSetFocus() {
	divMain.focus()
}


function fnFolderSetFocus() {
	divFolder.focus()
}


	// Button Methods
Button = {}

Button.fnClick = function(oButton) {
	if (getAttr(oButton,"gjsState")=="0") {
		setAttr(oButton,"src",getAttr(oButton,"gjsImageDown"))
		setAttr(oButton,"gjsState","1")
	}
	else {
		setAttr(oButton,"src",getAttr(oButton,"gjsImageUp"))
		setAttr(oButton,"gjsState","0")
	}
	oButton.blur();
	cmdOK.value='Select';
}

Button.fnMouseOver = function(oButton) {
  //stub
}

Button.fnMouseOut = function(oButton) {
  //stub
}


	// Public - Clear audit panel
function fnAuditClear() {
	// Remove all tbody elements from table, which is the second child of the div once AuditTrail_Load.xsl has filled it
	var oTable;
	oTable=divMessagesBody.children[1];
	if (oTable==null) return;
	while (oTable.tBodies.length>0) {
		oTable.removeChild(oTable.tBodies[0]);
	}
	//
	// Insert an empty tbody to keep column sorting/resizing happy even when empty
	oTable.appendChild(document.createElement('TBODY'))
}


	// Private - objects that have been through fnAbsoluteClippedRect
	// can be checked for overlap with this function
function fnObjectIntersect(o1,o2) {
	//
	if (o1.gjClippedTop>o2.gjClippedBottom) return false;
	else if (o2.gjClippedTop>o1.gjClippedBottom) return false;
	//
	if (o1.gjClippedLeft>o2.gjClippedRight) return false;
	else if (o2.gjClippedLeft>o1.gjClippedRight) return false;
	//
	return true;
}


	// Private - objects that have been through fnAbsoluteClippedRect
	// can be checked for overlap with this function
	// Treats o1 as zero-height rectangle located at its centreline
function fnObjectIntersectCentreLine(o1,o2) {
	//
	var y1=(o1.gjClippedTop+o1.gjClippedBottom)/2;
	if (y1>o2.gjClippedBottom) return false;
	else if (o2.gjClippedTop>y1) return false;
	//
	if (o1.gjClippedLeft>o2.gjClippedRight) return false;
	else if (o2.gjClippedLeft>o1.gjClippedRight) return false;
	//
	return true;
}


// Initial States
SelectedClass=Disabled; // Folder
SelectedClass.Current=Disabled; // Folder.Item
Worklist=Disabled;
SelectedObject=Disabled; // Enabled when an object is selected


// Overridable top-level event handlers

function fnOnKeyDown(e) {
		fnKeyDown(e);
		Menubar.fnAccessKeyHandler(e);
}

// Attach them using a .gJax namespace so an override in another .js can turn them off and substitute their own.
// The default function is deliberately a named one so an override can call it in cases
// where the override wants the default behaviour.
// See vcmyKeyboardShortcutExample.js for an example of how to do this.
$(function() {

	$(document, window).on('keydown.gJax',fnOnKeyDown);

});
