<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet 
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">

<!-- Select Toolbar (Disabled)
     =========================
-->

<xsl:include href='ServerLink.xsl' />


<xsl:template match="/ServerLink/Toolbars">
  <div id='divSelect'>
    <xsl:call-template name='toolbarSelect'/>
    <xsl:call-template name='toolbarFilters'/>
    <xsl:call-template name='toolbarWorkList'/>
  </div>
</xsl:template>


<!-- Selection toolbar (disabled, its just eye candy, it gets replaced by real working controls) -->
<xsl:template name='toolbarSelect'>
  <div id='divToolbarSelect' style='float: left;'>
    <table
     cellspacing='1px'
     cellpadding='1px'
     border='0px'>
      <tr>

        <td
         width='186px'>
          <select 
           id='lstSelect'
           style='width: 186px;'
           size='1'
           disabled='disabled'
           value=''
           class='input'>
          </select>
        </td>

        <td>
          <input
           id='cmdOK'
           disabled='disabled'
           type='submit'
           class='button'
           style='height: 22px; width: 60px; padding-top: 0px;'
           value='Select'/>
        </td>
      </tr>
    </table>
  </div>
</xsl:template>


<!-- Filter button toolbar (empty) -->
<xsl:template name='toolbarFilters'>
  <div id='divToolbarFilters' style='float: left;'>
  </div>
</xsl:template>


<!-- WorkList toolbar -->
<xsl:template name='toolbarWorkList'>
  <div id='divToolbarWorkList' style='float: right;'>
    <table
     width='10'
     cellspacing='1'
     cellpadding='2'
     border='0'>
      <tr>

        <td>
          <button
           class='button'
           type='button'
           id='cmdWorkList'
           style='height: 22px; width: 150px; top: 1px; position: relative;'
           onclick='fnWorkListPaste()'
           title='The Work List.  Drag Components here to add them to the list.  Use the Paste option to add them to a currently selected Object.  Objects and Change Requests can also be added to this list and pasted into a Change Request.  The work list can only contain one type of item at any time.'>
            <img
             style='position: relative; top: -1px;'
             src='vcm_bucket.gif'
             width='16px'
             height='16px'/>
            <span
             class='button'
             id='workListCaption'
             style='position: relative; top: -5px;'>
              0 items
            </span>
          </button>
        </td>
        <!-- Clear Work List Button, with 1px-width transparent image 16px high,
        so we get the same layout as adjacent button -->
        <td>
          <button
           class='button'
           type='button'
           id='cmdWorkListClear'
           style='height: 22px; width: 70px; top: 1px; position: relative;'
           onclick='fnWorkListClear()'
           title='Empty the contents of the work list'
           accesskey='l'>
            <img
             style='position: relative; top: -1px;'
             src='vcm_1px.gif'
             width='1px'
             height='16px'/>
            <span
             class='button'
             style='position: relative; top: -5px;'>
              C<u>l</u>ear
            </span>
          </button>
        </td>
      </tr>
    </table>
  </div>
</xsl:template>


</xsl:stylesheet>
